// "Indicator window thread" class is by Alexander Ilyin
// *original belongs at Drag Watcher project
// *hotkeys are here, because they need to belong at some window

#include "IWThread.h"
#include "error.h"


//CIndicatorWnd* indicator_window = NULL;
//DWORD thread_id__window = 0;
//HANDLE thread_handle__window = NULL;
//bool window_thread_is_working = 0;
bool iw_thread__quit = 0;


CIWThread::CIWThread ()
{
	is_working = 0;
	c_indicator_window = NULL;
	id__window = 0;
	handle__window = NULL;
//	quit = 0;
	lock_internal_count = 0;
	lock_external_count = 0;

	hotkeys = NULL;
	hotkeys_number = 0;
}

void CIWThread::SetHotKeysData (hotkey_info_t* hotkey_info, int hotkeys_num)
{
	hotkeys = hotkey_info;
	hotkeys_number = hotkeys_num;
}

void CIWThread::InitHotKeys ()
{
	int i;
//	uint position;
	CHotKeys* c_hot_keys;

	c_hot_keys = c_indicator_window->mc_hot_keys;
	Assert(c_hot_keys);
	for (i = 0; i < hotkeys_number; i++)
	{
//		c_hot_keys->Add (&hotkeys[i], &position);
//		c_hot_keys->Activation (position, 1);
		c_hot_keys->Add (&hotkeys[i]);
	}
}

void CIWThread::InitIndicatorWnd (HINSTANCE hInstance)
{
	c_indicator_window = new CIndicatorWnd;
	int x = GetSystemMetrics (SM_CXSCREEN);

	indicator_wnd__settings_t* settings = &c_indicator_window->m_settings;

	settings->transparent = 1;
	settings->transparency = 0x80000000;
	settings->on_top = 1;
	settings->no_taskbar_icon = 1;
	settings->drag_and_drop = 0;
	settings->pos_x = x * 2 / 3;
	settings->pos_y = 15;
	settings->size_x = 351;
	settings->size_y = 77;

//	c_indicator_window->Init (hInstance, IW_MODE_STRING, 1000);
//	c_indicator_window->Init (hInstance, IW_MODE_STRING);
	Lock ();
	c_indicator_window->Init (hInstance);
	c_indicator_window->Text_Put ("Initialization.");
	c_indicator_window->SetMode_Interaction (IW_STYLE_ACTIVE);
// test
	c_indicator_window->SetMode_Interaction (IW_STYLE_PASSIVE);
	c_indicator_window->SetMode_Output (IW_MODE_STRING);
	c_indicator_window->WindowUpdate ();
	UnLock ();

	wm_item_t item;
	item.type = WMENU_ITEM_TYPE__BUTTON;
	item.c_wnd_menu = NULL;
	item.text = "Quit";
	item.variable.function = NULL;
	item.variable.class_ptr = NULL;
	item.variable.ptr = &iw_thread__quit;
	c_indicator_window->mc_wnd_menu.Item_Insert (0, &item);
	c_indicator_window->InitTemplate ();
}

DWORD WINAPI CIWThread::WindowThread (LPVOID data)
{
	CIWThread* c_thread = (CIWThread*)data;

	c_thread->InitIndicatorWnd ((HINSTANCE)data);
	c_thread->InitHotKeys ();

//	window_thread_is_working = 1;
	c_thread->is_working = 1;

loop:
	c_thread->lock_internal_count++;
	if (! c_thread->lock_external_count)
		c_thread->c_indicator_window->Messaging ();
	c_thread->lock_internal_count--;
	Sleep (50);
	if (! iw_thread__quit)
		goto loop;
//	DWORD exit_code;
//	GetExitCodeThread (thread_handle__window, &exit_code);

	c_thread->is_working = 0;

	return 0;
}

bool CIWThread::Init (HINSTANCE hInstance)
{
//	SECURITY_ATTRIBUTES security_attributes;

	h_instance = hInstance;
//	security_attributes.nLength = sizeof(security_attributes);
//	security_attributes.lpSecurityDescriptor = NULL;
//	security_attributes.bInheritHandle = 1;
//	handle__window = CreateThread (&security_attributes, 0, WindowThread, this, 0, &id__window);
	handle__window = CreateThread (NULL, 0, WindowThread, this, 0, &id__window);
	if (! handle__window)
		return 0;
	while (! is_working)
		Sleep (1);

	return 1;
}

void CIWThread::Quit ()
{
	if (! handle__window)
		return;
	iw_thread__quit = 1;
	while (is_working)
		Sleep (1);
	handle__window = 0;
}

void CIWThread::Lock ()
{
// prevent locking loop
	Assert(lock_external_count < 5);
	lock_external_count++;
	while (lock_internal_count)
		Sleep (1);
}

void CIWThread::UnLock ()
{
	if (! lock_external_count)
//		return;
		Error ("'CIWThread::UnLock ()' :  trying to unlock not locked thread");
	lock_external_count--;
}

void CIWThread::Text_Put (char* text)
{
	Lock ();
	c_indicator_window->Text_Put (text);
	UnLock ();
}

