// "Indicator window thread" class is by Alexander Ilyin
// *original belongs at the Drag Watcher project

#pragma once

#include <windows.h>

#include "IndicatorWnd.h"


//extern CIndicatorWnd* indicator_window;
extern bool iw_thread__quit;


// *'CIndicatorWnd' isn't just class template, and must not be inherited here
class CIWThread
{
public:
	CIWThread ();
	void SetHotKeysData (hotkey_info_t* hotkey_info, int hotkeys_num);
	bool Init (HINSTANCE hInstance);
	void Quit ();
	void Lock (void);
	void UnLock (void);
	void Text_Put (char* text);

private:
	bool is_working;
	CIndicatorWnd* c_indicator_window;
	DWORD id__window;
	HANDLE handle__window;
//	bool quit;
	HINSTANCE h_instance;
// *for messaging
	int lock_internal_count;
// *for everything other
	int lock_external_count;
	hotkey_info_t* hotkeys;
	int hotkeys_number;

	void InitHotKeys ();
	void InitIndicatorWnd (HINSTANCE hInstance);
	static DWORD WINAPI WindowThread (LPVOID data);
};
