// class is by Alexander Ilyin
// *original belongs at the Drag Watcher project

#pragma once

#include <windows.h>

#include "WndMenu.h"
#include "types.h"
#include "hot_keys.h"
#include <string>
using namespace std;


typedef enum
{
	IW_MODE_NONE,
	IW_MODE_STRING,
	IW_MODE_TEXT,
//	IW_MODE_CONSOLE,
	IW_MODE_TRAFFIC,
	IW_MODE_BITMAP,
	IW_MODES_NUM
};

typedef enum
{
	IW_STYLE_NONE,
	IW_STYLE_PASSIVE,
	IW_STYLE_ACTIVE,
	IW_STYLES_NUM
};

typedef struct indicator_wnd__settings_s
{
	bool transparent;
//	float transparency;
	uint transparency;
//	bool topmost;
	bool on_top;
	bool no_taskbar_icon;
	bool drag_and_drop;
	int pos_x;
	int pos_y;
	int size_x;
	int size_y;
} indicator_wnd__settings_t;

class CIndicatorWnd
{
public:
// + settings +
	indicator_wnd__settings_t m_settings;
//	int m_mode;
// - settings -

	CWndMenu mc_wnd_menu;
	CHotKeys* mc_hot_keys;
//	HWND h_wnd;

	void InitFunctions ();
	CIndicatorWnd ();
//	bool Init (HINSTANCE h_instance, int window_mode, indicator_wnd__settings_t* settings, int text_buffer_size);
// *'window_mode' - not for the settings, because it is main property
//	bool Init (HINSTANCE h_instance, int window_mode, int text_buffer_size);
//	bool Init (HINSTANCE h_instance, int window_mode);
	bool Init (HINSTANCE h_instance);
	void InitTemplate ();
//	void MenuItem_Insert (int position, iw_popup_menu_item_t* menu_item);
	void Messaging (void);
	void Text_Put (char* text);
//	void SetMode (int mode);
//	void SetModes (int mode_style, int mode_output);
	void SetMode_Interaction (int mode);
	void SetMode_Output (int mode);
	void WindowUpdate ();

private:
	HINSTANCE mh_inst;
	int m_mode_interaction;
	int m_mode_output;
	HWND mh_wnd;
//	HMENU h_menu;
// text to output
//	char* text_buf;
// *perhaps this buffer will be needed only for the console mode
//	char* text_buf_new;
//	int txt_buf_size;
	string m_text_out;

	bool WindowCreate (void);
	static void VariableUpdate (void* variable_class_ptr);
	void Draw_Text (HDC hdc);
	void Draw_Bitmap (HDC hdc);
	void SetAttributes (void);
	LRESULT CALLBACK WndProc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK WndProcReq (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
};

