// class is by Alexander Ilyin
// *original belongs at the Drag Watcher project

#pragma once

#include <windows.h>


typedef void(* wm_variable_update_function) (void* variable_class_ptr);

class CWndMenu;

typedef enum
{
	WMENU_ITEM_TYPE__NONE,
	WMENU_ITEM_TYPE__GRAYED,
// *can't handle presses
	WMENU_ITEM_TYPE__SUBMENU,
	WMENU_ITEM_TYPE__SEPARATOR,
// just handles presses, without any indication of it
	WMENU_ITEM_TYPE__BUTTON,
//	WMENU_ITEM_TYPE__CHECKBOX,
	WMENU_ITEM_TYPE__CHECKABLE,
	WMENU_ITEM_TYPES_NUM
};

typedef struct
{
	int type;
	CWndMenu* c_wnd_menu;
	char* text;
	struct
	{
		wm_variable_update_function function;
		void* class_ptr;
		void* ptr;
	} variable;
} wm_item_t;


class CWndMenu
{
public:
	wm_item_t* items;
	int items_num;
	HMENU h_menu;
	bool initialized;

	CWndMenu ();
	~CWndMenu ();
	bool Init ();
	void Free ();
	bool Item_Put (int position, wm_item_t* item);
	bool Item_Insert (int position, wm_item_t* item);
	bool Submenu_Insert (int position, CWndMenu* c_wnd_menu, char* text);
	CWndMenu* Submenu_Create (int position, char* text);
	bool Item_Remove (int position);
	void Item_RemoveAll ();
// *this way is really wrong
//	void Show ();
//	void Hide ();

private:
	void OnMenuCommand (int position);
	friend void CWndMenu_OnMenuCommand (HMENU, int);
};

//void CWndMenu_OnMenuCommand (HMENU hmenu, int position);
