#pragma once

#include "types.h"
#include <windows.h>


// these may be very many, so pack them densitive
#pragma pack (push, 1)
typedef struct
{
	ulong address;
// *for break point is necessary only one byte, to put 0xcc (int 3) there
	byte byte_at_position;
	bool is_on;
} break_point_t;
#pragma pack (pop)


class BreakPoints
{
public:
//	void Init (uint points_num);
	BreakPoints (uint points_num);
//	void Quit ();
	~BreakPoints ();
	void SetHandleProcess (HANDLE handle_process);
	bool ByteRead (ulong address, byte& b);
	bool ByteWrite (ulong address, byte b);
	bool Add (ulong address, uint* ix);
//	bool Delete (uint ix);
	void Delete (uint ix);
	bool AddPointsByBooleanArray (ulong base_address, byte* array, uint size, uint& num_added);
//	bool IsOur (ulong address);
	bool Find (ulong address, uint& ix);
//	bool Enable (ulong address);
//	bool Disable (ulong address);
	bool Enable (uint ix);
	bool Disable (uint ix);
	void DumpRemained_ToLog (bool only_enabled);

// for debug purposes
	ulong m_bp_last_address_enabled;
	ulong m_bp_last_address_disabled;

private:
	HANDLE m_handle_process;
	uint m_points_allocated_num;
	uint m_points_num;
	break_point_t* m_break_points;
};

