// by Alexander Ilyin
// errors handling
// belongs at "Drag Watcher" project

#include "error.h"
#ifdef WIN32
#include <windows.h>
#else
#include <stdarg.h>
#endif
//#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#define PROJECT_NAME "Drag Watcher"
#define PROJECT_ERROR PROJECT_NAME" error"


//terminates with error code 1, printing message
void Error (char* format, ...)
{
va_list arglist;
char exit_message[256];

	strcpy (exit_message,"\nError: ");
	va_start(arglist, format);
	vsprintf (exit_message + strlen(exit_message), format, arglist);
	va_end(arglist);

	printf (exit_message);

#ifdef WIN32
	MessageBox (0, exit_message, PROJECT_ERROR, MB_OK);
#endif
#ifdef __unix__
	printf ("\a"PROJECT_ERROR" :  %s\n", buffer_string);
#endif

// *will call all declared by 'atexit()'
	exit(1);
}

// error, but not exit the process; continue
void Error_NoExit (char* format, ...)
{
va_list arglist;
char exit_message[256];

	strcpy (exit_message,"\nError: ");
	va_start(arglist, format);
	vsprintf (exit_message + strlen(exit_message), format, arglist);
	va_end(arglist);

	printf (exit_message);

	MessageBox (0, exit_message, 0, MB_OK);
}

void _Assert (int expr, char* expr_text, char* filename, int linenum)
{
	if (! (expr))
	{
		Error ("Assertion failed: %s, file %s, line %d", expr_text, filename, linenum);
	}
}

