// by Alexander Ilyin
//

#pragma once

#include "types.h"
//#define _NTSYSTEM_
#include <windows.h>

// XP
#undef WINVER
#define WINVER 0x0501
#define _WIN32_WINNT WINVER
#include <winternl.h>
#define STATUS_SUCCESS 0
//#define STATUS_PENDING                   ((NTSTATUS)0x00000103L)    // winnt
#define STATUS_BUFFER_OVERFLOW           ((NTSTATUS)0x80000005L)
#define STATUS_UNSUCCESSFUL              ((NTSTATUS)0xC0000001L)
#define STATUS_NO_SUCH_FILE              ((NTSTATUS)0xC000000FL)
#define STATUS_END_OF_FILE               ((NTSTATUS)0xC0000011L)
#define STATUS_OBJECT_NAME_NOT_FOUND     ((NTSTATUS)0xC0000034L)

#define FILENT_GETS_TYPICAL_STRING_SIZE 1024


bool CFileNT_Init ();

class CFileNT
{
public:
	NTSTATUS Open (UNICODE_STRING* file_name);
	NTSTATUS Open (void* file_name, int size);
	NTSTATUS Open (void* file_name);
	NTSTATUS Read (uint64 offset, void* buffer, uint length, uint64* bytes_read);
	NTSTATUS GetS (void* buffer, uint length, bool* end_of_file);
	bool Close ();
	LARGE_INTEGER file_size;
//	FILE_STANDARD_INFORMATION file_standard_information;
// + for usage outside of the class +
//	bool opened;
// (signed, for easier seek calculations)
//	__int64 offset;
// - for usage outside of the class -
private:
	HANDLE handle_file;
	uint64 gets_offset;
//	byte gets_buffer[FILENT_GETS_TYPICAL_STRING_SIZE * 2];
	byte gets_buffer[FILENT_GETS_TYPICAL_STRING_SIZE + 2];
};

