// by Alexander Ilyin

#include "handle_file.h"

//#include <psapi.h>

#include "error.h"
#include "string.h"


#define BUFFER_SIZE 512

//#include <ntddk.h>

// *for MSVC 6.0
#if _MSC_VER < 1300
#define __in
#define __out
#define __in_opt
// off; why it so long was on (?)
//#include "fileextd.h"

#include "types.h"

typedef ulong ULONG_PTR;

/*
typedef struct _UNICODE_STRING
{
	USHORT  Length;
	USHORT  MaximumLength;
	PWSTR  Buffer;
} UNICODE_STRING, *PUNICODE_STRING;
*/

typedef struct _STRING
{
	USHORT  Length;
	USHORT  MaximumLength;
	PCHAR  Buffer;
} ANSI_STRING, *PANSI_STRING;

//typedef DWORD (WINAPI* GetModuleFileNameEx_t) (HANDLE hProcess, HMODULE hModule, LPSTR lpFilename, DWORD nSize);
//GetModuleFileNameEx_t GetModuleFileNameEx = 0;
//typedef DWORD (WINAPI* GetProcessImageFileName_t) (HANDLE hProcess, LPTSTR lpImageFileName, DWORD nSize);
//GetProcessImageFileName_t GetProcessImageFileName = 0;
typedef BOOL(* GetVolumePathName_t) (LPCSTR lpszFileName, LPSTR lpszVolumePathName, DWORD cchBufferLength);
GetVolumePathName_t GetVolumePathName = 0;
typedef NTSTATUS(* IoVolumeDeviceToDosName_t) (IN  PVOID  VolumeDeviceObject, OUT PUNICODE_STRING  DosName);
IoVolumeDeviceToDosName_t IoVolumeDeviceToDosName = 0;
//typedef BOOL(* GetFileInformationByHandleEx_t) (HANDLE hFile, FILE_INFO_BY_HANDLE_CLASS FileInformationClass, LPVOID lpFileInformation, DWORD dwBufferSize);
//GetFileInformationByHandleEx_t GetFileInformationByHandleEx = 0;
//typedef NTSTATUS (__stdcall* RtlAnsiStringToUnicodeString_t) (IN OUT PUNICODE_STRING  DestinationString, IN PANSI_STRING  SourceString, IN BOOLEAN  AllocateDestinationString);
//RtlAnsiStringToUnicodeString_t RtlAnsiStringToUnicodeString = 0;
//typedef NTSTATUS(* IoGetDeviceObjectPointer_t) (IN PUNICODE_STRING  ObjectName, IN ACCESS_MASK  DesiredAccess, OUT PFILE_OBJECT  *FileObject, OUT PDEVICE_OBJECT  *DeviceObject);
//IoGetDeviceObjectPointer_t IoGetDeviceObjectPointer = 0;
// *needs higher than XP
typedef BOOL (WINAPI* QueryFullProcessImageName_t) (HANDLE hProcess, LPTSTR lpImageFileName, DWORD nSize);
QueryFullProcessImageName_t QueryFullProcessImageName = 0;

#ifdef __cplusplus
extern "C" {
#endif

WINBASEAPI
BOOL
WINAPI
GetVolumeInformationA(
    IN LPCSTR lpRootPathName,
    OUT LPSTR lpVolumeNameBuffer,
    IN DWORD nVolumeNameSize,
    OUT LPDWORD lpVolumeSerialNumber,
    OUT LPDWORD lpMaximumComponentLength,
    OUT LPDWORD lpFileSystemFlags,
    OUT LPSTR lpFileSystemNameBuffer,
    IN DWORD nFileSystemNameSize
    );
#define GetVolumeInformation  GetVolumeInformationA

WINBASEAPI
BOOL
WINAPI
GetVolumeNameForVolumeMountPointA(
    LPCSTR lpszVolumeMountPoint,
    LPSTR lpszVolumeName,
    DWORD cchBufferLength
    );
#define GetVolumeNameForVolumeMountPoint  GetVolumeNameForVolumeMountPointA

WINBASEAPI
BOOL
WINAPI
GetVolumePathNameA(
    LPCSTR lpszFileName,
    LPSTR lpszVolumePathName,
    DWORD cchBufferLength
    );
#define GetVolumePathName  GetVolumePathNameA

WINBASEAPI
BOOL
WINAPI
GetVolumePathNamesForVolumeNameA(
    LPCSTR lpszVolumeName,
    LPSTR lpszVolumePathNames,
    DWORD cchBufferLength,
    PDWORD lpcchReturnLength
    );
#define GetVolumePathNamesForVolumeName  GetVolumePathNamesForVolumeNameA

/*
NTSYSAPI 
NTSTATUS
NTAPI
NtQueryVirtualMemory(
  IN HANDLE               ProcessHandle,
  IN PVOID                BaseAddress,
//  IN MEMORY_INFORMATION_CLASS MemoryInformationClass,
  int mem_info_class,
  OUT PVOID               Buffer,
  IN ULONG                Length,
  OUT PULONG              ResultLength OPTIONAL );
*/

#ifdef __cplusplus
}
#endif

#else
#include "psapi.h"
#endif


#if 1

typedef struct _IO_STATUS_BLOCK
{
	union
	{
		NTSTATUS Status;
		PVOID Pointer;
	};

	ULONG_PTR Information;
} IO_STATUS_BLOCK, *PIO_STATUS_BLOCK;

typedef enum _FILE_INFORMATION_CLASS
{
    FileDirectoryInformation=1,
    FileFullDirectoryInformation,
    FileBothDirectoryInformation,
    FileBasicInformation,
    FileStandardInformation,
    FileInternalInformation,
    FileEaInformation,
    FileAccessInformation,
    FileNameInformation,
    FileRenameInformation,
    FileLinkInformation,
    FileNamesInformation,
    FileDispositionInformation,
    FilePositionInformation,
    FileFullEaInformation,
    FileModeInformation,
    FileAlignmentInformation,
    FileAllInformation,
    FileAllocationInformation,
    FileEndOfFileInformation,
    FileAlternateNameInformation,
    FileStreamInformation,
    FilePipeInformation,
    FilePipeLocalInformation,
    FilePipeRemoteInformation,
    FileMailslotQueryInformation,
    FileMailslotSetInformation,
    FileCompressionInformation,
    FileCopyOnWriteInformation,
    FileCompletionInformation,
    FileMoveClusterInformation,
    FileQuotaInformation,
    FileReparsePointInformation,
    FileNetworkOpenInformation,
    FileObjectIdInformation,
    FileTrackingInformation,
    FileOleDirectoryInformation,
    FileContentIndexInformation,
    FileInheritContentIndexInformation,
    FileOleInformation,
    FileMaximumInformation
} FILE_INFORMATION_CLASS, *PFILE_INFORMATION_CLASS;

#ifndef OPTIONAL
#define OPTIONAL
#endif
#ifndef NTAPI
#define NTAPI __stdcall
#endif

typedef NTSTATUS (WINAPI* NtQueryInformationFile_t) (HANDLE hFile, PIO_STATUS_BLOCK io, PVOID ptr, LONG len, FILE_INFORMATION_CLASS class_);
NtQueryInformationFile_t NtQueryInformationFile = 0;
typedef NTSYSAPI NTSTATUS (NTAPI* NtQueryVirtualMemory_t) (IN HANDLE ProcessHandle, IN PVOID BaseAddress, int mem_info_class, OUT PVOID Buffer, IN ULONG Length, OUT PULONG ResultLength OPTIONAL);
NtQueryVirtualMemory_t NtQueryVirtualMemory = 0;

// *temp
typedef void* PIO_APC_ROUTINE;

typedef NTSTATUS (NTAPI* NtQueryDirectoryFile_t)
(
	IN HANDLE FileHandle,
	IN HANDLE Event OPTIONAL,
	IN PIO_APC_ROUTINE ApcRoutine OPTIONAL,
	IN PVOID ApcContext OPTIONAL,
	OUT PIO_STATUS_BLOCK IoStatusBlock,
	OUT PVOID FileInformation,
	IN ULONG Length,
	IN FILE_INFORMATION_CLASS FileInformationClass,
	IN BOOLEAN ReturnSingleEntry,
	IN PUNICODE_STRING FileMask OPTIONAL,
	IN BOOLEAN RestartScan
);
NtQueryDirectoryFile_t NtQueryDirectoryFile = 0;

/*
typedef struct _ERESOURCE {
03028   LIST_ENTRY  SystemResourcesList;
03029   POWNER_ENTRY  OwnerTable;
03030   SHORT  ActiveCount;
03031   USHORT  Flag;
03032   PKSEMAPHORE  SharedWaiters;
03033   PKEVENT  ExclusiveWaiters;
03034   OWNER_ENTRY  OwnerThreads[2];
03035   ULONG  ContentionCount;
03036   USHORT  NumberOfSharedWaiters;
03037   USHORT  NumberOfExclusiveWaiters;
03038   _ANONYMOUS_UNION union {
03039     PVOID  Address;
03040     ULONG_PTR  CreatorBackTraceIndex;
03041   } DUMMYUNIONNAME;
03042   KSPIN_LOCK  SpinLock;
03043 } ERESOURCE, *PERESOURCE;
*/

#define ERESOURCE int
#define OBJECT_TYPE_INITIALIZER int

typedef struct _OBJECT_TYPE
{
    ERESOURCE Mutex;
    LIST_ENTRY TypeList;
    UNICODE_STRING Name;
    PVOID DefaultObject;
    ULONG Index;
    ULONG TotalNumberOfObjects;
    ULONG TotalNumberOfHandles;
    ULONG HighWaterNumberOfObjects;
    ULONG HighWaterNumberOfHandles;
    OBJECT_TYPE_INITIALIZER TypeInfo;
    ULONG Key;
    ERESOURCE ObjectLocks[4];
} OBJECT_TYPE;

typedef struct _OBJECT_TYPE *POBJECT_TYPE;

typedef struct _OBJECT_HANDLE_INFORMATION {
    ULONG HandleAttributes;
    ACCESS_MASK GrantedAccess;
} OBJECT_HANDLE_INFORMATION, *POBJECT_HANDLE_INFORMATION;

typedef enum _MODE {
    KernelMode,
    UserMode,
    MaximumMode
} MODE;
 
typedef CCHAR KPROCESSOR_MODE;


typedef NTSTATUS(* ObReferenceObjectByHandle_t)
(
    IN HANDLE  Handle,
    IN ACCESS_MASK  DesiredAccess,
//    IN POBJECT_TYPE  ObjectType  OPTIONAL,
	void* obj_type_ptr,
    IN KPROCESSOR_MODE  AccessMode,
    OUT PVOID  *Object,
//    OUT POBJECT_HANDLE_INFORMATION  HandleInformation  OPTIONAL
	void* obj_handle_info_ptr
);
ObReferenceObjectByHandle_t ObReferenceObjectByHandle;

/*
typedef VOID(* ObDereferenceObject_t)
(
    IN PVOID  Object
);
ObDereferenceObject_t ObDereferenceObject;
*/

#ifdef __cplusplus
extern "C" {
#endif

#define NTKERNELAPI DECLSPEC_IMPORT

/*
#define DECLSPEC_IMPORT __declspec(dllimport)
//#define DECLSPEC_IMPORT

typedef LONG NTSTATUS;

NTKERNELAPI                                                     
NTSTATUS
ObReferenceObjectByHandle(                                      
    IN HANDLE Handle,                                           
    IN ACCESS_MASK DesiredAccess,                               
    IN POBJECT_TYPE ObjectType OPTIONAL,                        
    IN KPROCESSOR_MODE AccessMode,                              
    OUT PVOID *Object,
    OUT POBJECT_HANDLE_INFORMATION HandleInformation OPTIONAL   
    );                                                          
*/

//extern POBJECT_TYPE *IoFileObjectType;
//extern POBJECT_TYPE *ExEventObjectType;
//extern POBJECT_TYPE *ExSemaphoreObjectType;

extern void** IoFileObjectType;
extern void** ExEventObjectType;
extern void** ExSemaphoreObjectType;

#define FASTCALL _fastcall

NTKERNELAPI
LONG
FASTCALL
ObfDereferenceObject(
    IN PVOID Object
    );

#define ObDereferenceObject(a)                                     \
        ObfDereferenceObject(a)

#ifdef __cplusplus
}
#endif

#endif


// - defines -
#define POW2_SIZE(result,val) {result = 1; while (result < val) {result *= 2;}}


void HandleFile_InitFunctions ()
{
#if _MSC_VER < 1300
#endif
//HMODULE h_psapi;
//HMODULE h_kernel32;
//HMODULE h_ntkrnl;
HMODULE h_ntdll;
//HMODULE h_filename;

//	h_kernel32 = GetModuleHandle (TEXT("KERNEL32"));
//	h_psapi = LoadLibrary (TEXT("PSAPI"));
//	h_ntkrnl = LoadLibrary (TEXT("NTOSKRNL.EXE"));
//	h_ntkrnl = GetModuleHandle (TEXT("NTOSKRNL.EXE"));
	h_ntdll = GetModuleHandle (TEXT("NTDLL"));
//	h_filename = LoadLibrary (TEXT("FILENAME.DLL"));

//	if (h_psapi)
//		*(FARPROC*)&GetModuleFileNameEx = GetProcAddress (h_psapi, "GetModuleFileNameExA");
//		*(FARPROC*)&GetModuleFileNameEx = GetProcAddress (h_psapi, "GetModuleBaseNameA");
//		*(FARPROC*)&GetProcessImageFileName = GetProcAddress (h_psapi, "GetProcessImageFileNameA");
//		*(FARPROC*)&GetProcessImageFileName = GetProcAddress (h_psapi, "GetProcessImageFileNameW");
//	else
//		Error ("'LoadLibrary (\"psapi.dll\")' failed");

//		*(FARPROC*)&GetVolumePathName = GetProcAddress (h_kernel32, "GetVolumePathNameA");
//		*(FARPROC*)&IoVolumeDeviceToDosName = GetProcAddress (h_ntkrnl, "RtlVolumeDeviceToDosName");
//		*(FARPROC*)&IoVolumeDeviceToDosName = GetProcAddress (h_ntkrnl, "IoVolumeDeviceToDosName");
//		*(FARPROC*)&RtlAnsiStringToUnicodeString = GetProcAddress (h_ntkrnl, "RtlAnsiStringToUnicodeString");
//		*(FARPROC*)&IoGetDeviceObjectPointer = GetProcAddress (h_ntkrnl, "IoGetDeviceObjectPointer");
		*(FARPROC*)&NtQueryInformationFile = GetProcAddress (h_ntdll, "NtQueryInformationFile");
		*(FARPROC*)&NtQueryDirectoryFile = GetProcAddress (h_ntdll, "NtQueryDirectoryFile");
		*(FARPROC*)&NtQueryVirtualMemory = GetProcAddress (h_ntdll, "NtQueryVirtualMemory");
//		*(FARPROC*)&ObReferenceObjectByHandle = GetProcAddress (h_ntkrnl, "ObReferenceObjectByHandle");
//		*(FARPROC*)&ObDereferenceObject = GetProcAddress (h_ntkrnl, "ObDereferenceObject");
//		*(FARPROC*)&ObReferenceObjectByHandle = GetProcAddress (h_ntdll, "ObReferenceObjectByHandle");
//		*(FARPROC*)&ObDereferenceObject = GetProcAddress (h_ntdll, "ObDereferenceObject");
//		*(FARPROC*)&HandleFile_GetFileName = GetProcAddress (h_filename, "HandleFile_GetFileName");

	if (! NtQueryInformationFile)
		Error ("'GetProcAddress (h_ntdll, \"NtQueryInformationFile\")' failed");
	if (! NtQueryDirectoryFile)
		Error ("'GetProcAddress (h_ntdll, \"NtQueryDirectoryFile\")' failed");
	if (! NtQueryVirtualMemory)
		Error ("'GetProcAddress (h_ntdll, \"NtQueryVirtualMemory\")' failed");
}

#include <sys/stat.h>
#include <io.h>
#include <fcntl.h>
#include <direct.h>
#include <stdio.h>

#if 0

#ifdef __cplusplus
extern "C" {
#endif

//int __declspec(dllimport) __stdcall HF_GetFileName (DWORD process_id, HANDLE h_process, void* base_of_image, HANDLE file_handle, char* text_buffer, int buffer_size);

#ifdef __cplusplus
}
#endif

#endif

typedef enum _MEMORY_INFORMATION_CLASS
{
	MemoryBasicInformation,
	MemoryWorkingSetList,
	MemorySectionName,
	MemoryBasicVlmInformation
} MEMORY_INFORMATION_CLASS;


#if 0

// test
bool HandleFile_GetFileName (DWORD process_id, HANDLE h_process, void* base_of_image, HANDLE file_handle, char* text_buffer, int buffer_size)
{
char buffer[BUFFER_SIZE];
PFILE_NAME_INFO pfile_name_info = (PFILE_NAME_INFO)buffer;
//bool result = 1;
NTSTATUS ntstatus;
BOOL B_result;
DWORD D_result;
DWORD dw;
//HANDLE h_process;
//void* object;

//	HandleFile_GetFileName (process_id, h_process, base_of_image, file_handle, text_buffer, buffer_size);

//	NtQueryVirtualMemory (h_process, base_of_image, MemorySectionName, [ebp-214h], 0x210, [ebp-218h]);
//	ntstatus = NtQueryVirtualMemory (h_process, base_of_image, 2, buffer, BUFFER_SIZE, &dw);
//	__asm int 3
//	ObReferenceObjectByHandle (h_process, 0, 0, KernelMode, &object, 0);
//	ObReferenceObjectByHandle (h_process, 0, (POBJECT_TYPE)*IoFileObjectType, KernelMode, &object, 0);
//	ObReferenceObjectByHandle (h_process, 0, *IoFileObjectType, KernelMode, &object);
//	ObDereferenceObject (object);
	ntstatus = NtQueryVirtualMemory (h_process, base_of_image, MemorySectionName, buffer, BUFFER_SIZE, &dw);
	ntstatus = NtQueryVirtualMemory (h_process, base_of_image, MemoryBasicVlmInformation, buffer, BUFFER_SIZE, &dw);
	ntstatus = NtQueryVirtualMemory (h_process, base_of_image, MemoryWorkingSetList, buffer, BUFFER_SIZE, &dw);

// ? 'IoQueryFileInformation ()'

// ------------------------------------   1   --------------------------------------------
// not working before process start

// 'GetModuleBaseName ()' is the same, but gives just file name
// *the module list may not have been created yet
// *Here are two rules (for the DLLs is only first rule), when take the name becomes possible :
// 1) Can't get the name, while the process isn't working yet.
// It becomes possible after 'ContinueDebugEvent ()' request, but not immediatly, but at least 'Sleep (0)' is needed
// 2) For the main executable of the process it becomes possible after
// "C:\WINDOWS\system32\ntdll.dll" loading event (it is the first event for the DLLs),
// after 'ContinueDebugEvent ()' request, at the same moment as in the rule 1.
// *previewing by 'OpenProcess (process_id)' not helps too

//	h_process = OpenProcess (PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, process_id);
//	D_result = GetModuleFileNameEx (h_process, (HINSTANCE)base_of_image, buffer, BUFFER_SIZE);

//	d_result = GetModuleBaseName (h_process, (HINSTANCE)base_of_image, buffer, BUFFER_SIZE);
//	FILE_NAME_INFO file_name_info;
//	file_name_info.FileName = buffer;
//	GetFileInformationByHandleEx (file_handle, FileNameInfo, buffer, BUFFER_SIZE);
// 'KsQueryInformationFile ()'
// ZwQueryInformationFile
// IoGetDeviceObjectPointer
// ObReferenceObjectByHandle

//	if (! GetFileInformationByHandleEx (file_handle, FileNameInfo, pfile_name_info, sizeof(buffer)))
//		return 0;

// ------------------------------------   2   --------------------------------------------
// PSAPI

typedef union _PSAPI_WORKING_SET_BLOCK
{
  ULONG_PTR Flags;
  struct
  {
    ULONG_PTR Protection  :5;
    ULONG_PTR ShareCount  :3;
    ULONG_PTR Shared  :1;
    ULONG_PTR Reserved  :3;
    ULONG_PTR VirtualPage  :20;
  };
} PSAPI_WORKING_SET_BLOCK, *PPSAPI_WORKING_SET_BLOCK;

typedef struct _PSAPI_WORKING_SET_INFORMATION
{
  ULONG_PTR NumberOfEntries;
  PPSAPI_WORKING_SET_BLOCK WorkingSetInfo[1];
} PSAPI_WORKING_SET_INFORMATION, *PPSAPI_WORKING_SET_INFORMATION;

	PSAPI_WORKING_SET_INFORMATION psapi_working_set_information[100];
	B_result = QueryWorkingSet (h_process, &psapi_working_set_information, sizeof(psapi_working_set_information));

	PPSAPI_WORKING_SET_BLOCK* ppsapi_working_set_block = psapi_working_set_information[0].WorkingSetInfo;

// ------------------------------------   3   --------------------------------------------
// mapping

  TCHAR pszFilename[MAX_PATH+1];
 HANDLE hFileMap;

  // Get the file size.
  DWORD dwFileSizeHi = 0;
  DWORD dwFileSizeLo = GetFileSize(file_handle, &dwFileSizeHi); 

  if( dwFileSizeLo == 0 && dwFileSizeHi == 0 )
  {
//     printf("Cannot map a file with a length of zero.\n");
     return 0;
  }

  // Create a file mapping object.
  hFileMap = CreateFileMapping(file_handle, 
                    0, 
                    PAGE_READONLY,
                    0, 
                    1,
                    0);

  if (hFileMap) 
  {
    // Create a file mapping to get the file name.
    void* pMem = MapViewOfFile(hFileMap, FILE_MAP_READ, 0, 0, 1);

    if (pMem) 
    {
	__asm int 3
// *returns internal Windows name, like "\Device\HarddiskVolume1\....."
      (GetMappedFileName (GetCurrentProcess(), 
                             pMem, 
                             pszFilename,
                             MAX_PATH)) ;
	}
  }

	D_result = GetModuleFileNameEx (h_process, (HINSTANCE)base_of_image, buffer, BUFFER_SIZE);

// ------------------------------------   4   --------------------------------------------
// GetVolume

	DWORD dw1;
	DWORD dw2;
	DWORD dw3;
	char buffer2[1000];

	B_result = GetVolumeInformation (pszFilename, buffer, BUFFER_SIZE, &dw1, &dw2, &dw3, buffer2, 1000);

	B_result = GetVolumePathNameA (pszFilename, buffer, BUFFER_SIZE);

	B_result = GetVolumePathNamesForVolumeName (pszFilename, buffer, BUFFER_SIZE, &dw);

	B_result = GetVolumeNameForVolumeMountPointA (pszFilename, buffer, BUFFER_SIZE);
	B_result = GetVolumePathNamesForVolumeName (buffer, pszFilename, MAX_PATH, &dw);

// ------------------------------------   5   --------------------------------------------
// oooold

	IO_STATUS_BLOCK io;
	struct stat buf;
	int result;
	int handle;

//	wine_server_handle_to_fd( hFile, 0, &fd, 0 );
	ntstatus = NtQueryInformationFile (file_handle, &io, buffer, BUFFER_SIZE, FileInternalInformation);
//	result = fstat (*(int*)buffer, &buf);
	handle =  _open_osfhandle ((long)file_handle, _O_RDONLY);
	FILE* file = fdopen (handle, "r");
	result = fstat (handle, &buf);
	int drive = _getdrive ();
	result = fclose (file);
//	result = _close (handle);

// ------------------------------------   6   --------------------------------------------
// NT

	ntstatus = NtQueryInformationFile (file_handle, &io, buffer, BUFFER_SIZE, FileNameInformation);
	ntstatus = NtQueryInformationFile (file_handle, &io, buffer, BUFFER_SIZE, FileStreamInformation);
	__asm int 3
	ntstatus = NtQueryDirectoryFile (file_handle, 0, 0, 0, &io, buffer, BUFFER_SIZE, FileDirectoryInformation, 1, 0, 0);
	ntstatus = NtQueryDirectoryFile (file_handle, 0, 0, 0, &io, buffer, BUFFER_SIZE, FileFullDirectoryInformation, 1, 0, 0);
	ntstatus = NtQueryDirectoryFile (file_handle, 0, 0, 0, &io, buffer, BUFFER_SIZE, FileBothDirectoryInformation, 1, 0, 0);

	if (! String_UnicodeToANSI (text_buffer, buffer_size, pfile_name_info->FileName, pfile_name_info->FileNameLength))
		return 0;

	if (*text_buffer == '\\')
// a hack against 'NtQueryInformationFile ()' bug
	{
		StringN_InsertChar (text_buffer, buffer_size, ':', 0);
		StringN_InsertChar (text_buffer, buffer_size, 'C', 0);
	}

	return 1;
}

#else

// hmmm, who initializes 'unicode_string_buffer->Buffer' ? - if a function requires buffer size, then it is that function's job to fill all three fields in the 'UNICODE_STRING' struct
//bool HandleFile_GetFileName (DWORD process_id, HANDLE h_process, void* base_of_image, HANDLE file_handle, ushort* text_buffer, int buffer_size)
bool HandleFile_GetFileName (DWORD process_id, HANDLE h_process, void* base_of_image, HANDLE file_handle, UNICODE_STRING* text_buffer, int buffer_size)
{
//char buffer[BUFFER_SIZE];
//PUNICODE_STRING unicode_string_buffer = (PUNICODE_STRING)buffer;
//bool result = 1;
NTSTATUS ntstatus;
DWORD dw;

//	__asm int 1
	ntstatus = NtQueryVirtualMemory (h_process, base_of_image, MemorySectionName, text_buffer, BUFFER_SIZE, &dw);
//	ntstatus = NtQueryVirtualMemory (h_process, 0, MemorySectionName, unicode_string_buffer, BUFFER_SIZE, &dw);
//	if (ntstatus != STATUS_SUCCESS)
	if (ntstatus)
		return 0;

//	if (! String_UnicodeToANSI (text_buffer, buffer_size, unicode_string_buffer->Buffer, unicode_string_buffer->Length))
//		return 0;

	return 1;
}

#endif

