#pragma once

#include <windows.h>
#include "types.h"


#define HOTKEYS_MAX 100


typedef void(* HotKeyFunction_t) (void* user_data);

typedef struct
{
	UINT modifier;
	UINT vkey_code;
	HotKeyFunction_t function;
	void* user_data;
	bool* bool_ptr;
} hotkey_info_t;

typedef struct
{
	bool used;
	bool active;
	hotkey_info_t info;
} hotkey_t;

class CHotKeys
{
private:
	void Init ();
public:
	CHotKeys ();
	CHotKeys (HWND hwnd);
	~CHotKeys ();
	void SetHwnd (HWND hwnd);
	bool Find (hotkey_info_t* hotkey_info, uint* position = 0);
	bool Add (hotkey_info_t* hotkey_info, uint* position = 0, bool activate = 1);
	bool Remove (uint position);
private:
	void ActivationFailReport (uint index);
public:
	bool Activation (uint index, bool on = 1);
	bool ActivateAll (bool on = 1);
	void OnHotKey (uint index);

private:
	HWND m_hwnd;
// non-stack array
	hotkey_t m_hotkeys[HOTKEYS_MAX];
	char m_reports_buffer[256];
};
