// by Alexander Ilyin
// logging into file
// *original belongs at the Drag Watcher project


#include "log_file.h"
#include <windows.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include "error.h"


#define LOG_FILE_NAME "log.txt"

// == output log file ==
//static FILE* log_file = 0;
static HANDLE handle_log_file = 0;

static va_list argptr;
#define VA_PRINTF \
	va_start (argptr, format); \
	vsprintf (string, format, argptr); \
	va_end (argptr);


// maybe 'LogFile_Init ()' ? since it doesn't closes the handle
void LogFile_Clear ()
{
#if 0
	Assert(! log_file);
	log_file = fopen (LOG_FILE_NAME, "w");
	fclose (log_file);
	log_file = 0;
#endif

//	handle_log_file = CreateFile (LOG_FILE_NAME, GENERIC_WRITE, FILE_SHARE_READ, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
// create new, removing old content if already was existing
	handle_log_file = CreateFile (LOG_FILE_NAME, GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);

	if (handle_log_file == INVALID_HANDLE_VALUE) 
		Error ("Can't open log file.");

	DWORD D_result = SetFilePointer (handle_log_file, 0, NULL, FILE_BEGIN);
	if (D_result == 0xffffffff)
		Error ("'LogFile_____ ()' :  'SetFilePointer ()' fails");

	BOOL B_result = SetEndOfFile (handle_log_file);
	if (B_result == 0)
		Error ("'LogFile______ ()' :  'SetEndOfFile ()' fails");
}

void LogFile_Print (char* string)
{
//	Assert(! log_file);

//	log_file = fopen (LOG_FILE_NAME, "a");
//	fprintf (log_file, string);
//	fclose (log_file);
//	log_file = 0;

	int i;
	int string_length = strlen (string);
	BOOL B_result;
	DWORD bytes_written = 0;

	Assert(!! handle_log_file);
	DWORD D_result = SetFilePointer (handle_log_file, 0, 0, FILE_END);
	if (D_result == 0xffffffff)
		Error ("'LogFile_Print ()' :  'SetFilePointer ()' fails");

//	B_result = WriteFile (handle_log_file, string, strlen (string), &bytes_written, 0);
//	if (B_result == 0)
//		Error ("'LogFile_Print ()' :  'WriteFile ()' fails");

// handle line endings
	for (i = 0; i < string_length; i++)
	{
		char character = string[i];

		if (character == '\n')
		{
			B_result = WriteFile (handle_log_file, "\r", 1, &bytes_written, 0);
			if (B_result == 0)
				Error ("'LogFile_Print ()' :  'WriteFile ()' fails");
		}

		B_result = WriteFile (handle_log_file, &character, 1, &bytes_written, 0);
		if (B_result == 0)
			Error ("'LogFile_Print ()' :  'WriteFile ()' fails");
	}

//	CloseHandle (handle_log_file);

	return;
}

void LogFile_Error (char* text)
{
	LogFile_Print (text);

	exit (1);
}

void LogFile_Printf (char* format, ...)
{
static char string[1024];

	VA_PRINTF;

	LogFile_Print (string);

	return;
}

void LogFile_Warningf (char* format, ...)
{
static char string[1024];

	VA_PRINTF;

	LogFile_Printf ("warning :  %s",string);

	return;
}

void LogFile_Errorf (char* format, ...)
{
static char string[1024];

	VA_PRINTF;

	LogFile_Printf ("error :  %s",string);

	exit (1);
}

