// by Alexander Ilyin
// the dragging registering process
// and currently the main handling of dragging registering is here too

#include "reg_drag.h"

//#include <windows.h>
//#include <assert.h>
#include <stdio.h>
// test
//#include <iostream>
#include <sstream>

#include "log_file.h"
#include "args.h"
#include "trayicon.h"
#include "sorting.h"
#include "displaying.h"
#include "string.h"
#include "IWThread.h"
#include "error.h"
#include "handle_file.h"
#include "break_points.h"
// ohoh
//#include "file_nt.h"
bool CFileNT_Init ();


typedef enum
{
	REGISTERING_STATE__NONE,
	REGISTERING_STATE__PAUSE,
	REGISTERING_STATE__REGISTERING,
	REGISTERING_STATE__FINISHING,
	REGISTERING_STATES_NUM
};

typedef enum
{
//	HOTKEY_NONE,
// quit immediately
	HOTKEY_QUIT,
// allow registering
	HOTKEY_REGISTER,
// pause registering
	HOTKEY_PAUSE,
// write current data
	HOTKEY_WRITE,
// begin exit sequence
	HOTKEY_EXIT,
// clear all registered data
	HOTKEY_CLEAR,
	HOTKEYS_NUM
};

#define THREADS_MAX 256


// +++ settings +++
// *time periods can be in float point format, but not the time itself
// + periods +
// gives the process time, to initialize itself
double time_period__initializing = 2.0;
double time_period__registering = 20.0;
double time_period__finishing = 5.0;
// - periods -
// + sleeps +
// OS multitasking manager time chunk
// by default, Win98 have 55 ms period; WinNT have 10 ms period
double multimedia_timer_period = 0.001;
// which period to sleep (sec)
double sleep_time__wait = 0.1;
double sleep_time__register = 0.001;
// - sleeps -
// *must not be in settings
// *probably must be defined from PE
//uint code_offset = 0x00001000;
int break_on_exception_inside_process = 0;
int break_on_exception_outside_process = 0;
int events_resets_timer = 1;
int exception_events_max = 100;
//bool read_map_files = 1;
bool read_map_main_exe = 1;
bool read_map_loaded_dlls = 1;
// + registering mode +
bool use_timers = 0;
bool write_pauses = 1;
bool clear_pauses = 1;
// - registering mode -
// + multithread +
//bool regdrag_register_from_all_threads = 0;
uint regdrag_register_from_thread_ix = 0;
bool regdrag_reusing_thread_pointers = 0;
char* regdrag_register_from_threads_str = 0;
// *indices for this are not the same as for threads handles/ids, don't mess with that
uint regdrag_register_from_threads_ixes[THREADS_MAX] = {0};
uint regdrag_register_from_threads_num = 0;
bool regdrag_threads_suspend = 1;
// - multithread -
// + breakpoints +
uint regdrag_breakpoints_allocate_num = 0;
// - breakpoints -
// + hotkeys +
bool hotkeys_modifier_change = 0;
// - hotkeys -
// --- settings ---

// +++ directories +++
char* regdrag_dir_watcher_working_arg = 0;
char* regdrag_dir_process_exe_arg = 0;
char* regdrag_dir_process_working_arg = 0;
char regdrag_dir_watcher_executable[PATH_BUFFER_SIZE];
char regdrag_dir_watcher_working[PATH_BUFFER_SIZE];
char regdrag_dir_process_executable[PATH_BUFFER_SIZE];
char regdrag_dir_process_working[PATH_BUFFER_SIZE];
// --- directories ---

// +++ debugging thread parameters +++
// *set in "args.cpp"
char regdrag_process_executable_file_name[PATH_BUFFER_SIZE];
// *set in "args.cpp"
// quotes are not supported atm, maybe some bit later
char* regdrag_process_args_arg = 0;
//char regdrag_process_args[PATH_BUFFER_SIZE];
//char regdrag_process_executable_path[PATH_BUFFER_SIZE];
char regdrag_process_cmdline[PATH_BUFFER_SIZE];
// how I bored with that buffer management; enough, now will be normal C++ :)
string regdrag_str_process_executable_path;
string regdrag_str_process_cmdline;
HANDLE regdrag_h_process = 0;
HANDLE regdrag_h_thread = 0; // handle of debugging thread
DWORD process_id = 0;
// --- debugging thread parameters ---

// +++ process memory +++
//LPVOID base_of_image = 0;
//uint process_region_size = -1;
CWatchImage* c_images[IMAGES_MAX];
int images_num = 0;
// --- process memory ---

// +++ registering +++
// memory for registering
//uint *registration_array;
// size of this memory
//int module_size;
//bool quit = 0;

__int64 inside_process = -1;
__int64 outside_process = -1;
__int64 total_hits = -1;
int timer_registering = 0;
// --- registering ---

static void* reg_drag__address_last_exception = 0;
static int reg_drag__exceptions_repetition_counter = 0;

DWORD thread_ids[THREADS_MAX] = {0};
// *'regdrag_is_thread_cell_in_use[]' indicates that the thread does exist or not
HANDLE h_threads[THREADS_MAX] = {0};
bool regdrag_is_thread_cell_in_use[THREADS_MAX] = {0};
int regdrag_threads_num = 0;

// +++ work/displayable +++
bool at_least_Win2K = 0;
//DWORD thread_id__main = 0;
CIWThread c_iw_thread;
int registering_state = REGISTERING_STATE__NONE;
// looks like exe can load another exe, so this must not be bool then
int process_active = 0;
bool regdrag_flag__registered_thread_is_active = 0;
// --- work/displayable ---

// +++ controlling +++
hotkey_info_t hotkey_infos[HOTKEYS_NUM];
bool hotkey_is_pressed[HOTKEYS_NUM];
// --- controlling ---

// +++ process priority +++
// this configuration is optimal, and some other will be necessary only very rare
// don't use high level priority, because it blocks work of kernel drivers, so they work pulsive
// Above Normal
int process_priority__watcher = 1;
// Normal
int process_priority__exe = 0;
// --- process priority ---

// + breakpoints +
BreakPoints* regdrag_breakpoints = 0;
// - breakpoints -


int Image_Find (DWORD address)
{
int i;

	for (i = 0; i < images_num; i++)
	{
		CWatchImage* c_image = c_images[i];
		if (c_image->IsAddressInImage (address))
			return i;
	}

	return -1;
}

#if ! defined BELOW_NORMAL_PRIORITY_CLASS
#define BELOW_NORMAL_PRIORITY_CLASS       0x00004000
#define ABOVE_NORMAL_PRIORITY_CLASS       0x00008000
#endif

bool ProcessPriority_Set (HANDLE process_handle, char* process_name, int priority_level)
{
	BOOL B_result;
	DWORD priority_class;

	if (priority_level < -2)
	{
//		error = "level is less than -2";
		LogFile_Printf ("\n----- Warning in 'ProcessPriority_Set ()' :  can't set process priority to %d, %d is minimum -----\n", priority_level, -2);
//		return 0;
		goto error;
	}
	if (priority_level >= 4)
	{
//		error = "level is greater or equal than 4";
		LogFile_Printf ("\n----- Warning in 'ProcessPriority_Set ()' :  can't set process priority to %d, values below %d are available -----\n", priority_level, 4);
//		return 0;
		goto error;
	}
	switch (priority_level)
	{
	case -2:
		priority_class = IDLE_PRIORITY_CLASS;
		break;
	case -1:
		priority_class = BELOW_NORMAL_PRIORITY_CLASS;
		break;
	case 0:
		priority_class = NORMAL_PRIORITY_CLASS;
		break;
	case 1:
		priority_class = ABOVE_NORMAL_PRIORITY_CLASS;
		break;
	case 2:
		priority_class = HIGH_PRIORITY_CLASS;
		break;
	case 3:
		priority_class = REALTIME_PRIORITY_CLASS;
		break;
	default:
		LogFile_Printf ("\n----- Error in 'ProcessPriority_Set ()' :  undefined priority level  %d -----\n", priority_level);
//		return 0;
		goto error;
	}
	B_result = SetPriorityClass (process_handle, priority_class);
	if (B_result)
		return 1;
	LogFile_Printf ("\n----- 'ProcessPriority_Set ()' :  SetPriorityClass () failed for priority level  %d -----\n", priority_level);
error:
	LogFile_Printf ("----- process name \"%s\" -----\n", process_name);
// bug in MSVC :  compiles without this without even warning, and then the program is dead-looping last command
	return 0;
}

bool RegDrag_ThreadContext_Get (uint thread_ix, CONTEXT* context)
{
	BOOL B_result;
	DWORD D_result;
//	CONTEXT context;
//	DWORD Eip;
	static bool warning_1 = 0;
	HANDLE h_thread;
	DWORD id;

	Assert(regdrag_is_thread_cell_in_use[thread_ix]);
	id = thread_ids[thread_ix];
	h_thread = h_threads[thread_ix];
//	if (! h_thread)
// thread does not exist
//		return 0;
	Assert(h_thread);
// I need only EIP
//	context.ContextFlags = CONTEXT_CONTROL; // CONTEXT_FULL
// in such kind of debug, the suspending isn't mandatory;
// although I also can say, that with suspend, the result is slightly better :
// 1.26 times less breaks in "ntdll.dll", 1.49 times more breaks in the process, and even the period time is smaller (like 1.054ms instead of 1.145ms)
	if (regdrag_threads_suspend)
		D_result = SuspendThread (h_thread);
	B_result = GetThreadContext (h_thread, context);
	if (regdrag_threads_suspend)
		D_result = ResumeThread (h_thread);
	if (! B_result)
	{
		if (! warning_1)
		{
			LogFile_Printf ("\n----- Warning (only once showing) in 'RegDrag_ThreadContext_Get ()' :  can't get thread context by thread handle %08x (id %08x) -----\n\n", h_thread, id);
			warning_1 = 1;
		}

		return 0;
	}

//	Eip = context.Eip;

	return 1;
}

bool RegDrag_ThreadContext_Set (uint thread_ix, CONTEXT* context)
{
	BOOL B_result;
	static bool warning_1 = 0;
	HANDLE h_thread;
	DWORD id;

	id = thread_ids[thread_ix];
	h_thread = h_threads[thread_ix];
	B_result = SetThreadContext (h_thread, context);
	if (! B_result)
	{
		if (! warning_1)
		{
			LogFile_Printf ("\n----- Warning (only once showing) in 'RegDrag_ThreadContext_Set ()' :  can't set thread context by thread handle %08x (id %08x) -----\n\n", h_thread, id);
			warning_1 = 1;
		}

		return 0;
	}

	return 1;
}

// returns 0 if was unable to register
bool RegDrag_RegisterPoint_InThread (uint thread_ix)
{
	bool result;
//	BOOL B_result;
//	DWORD D_result;
	CONTEXT context;
//	DWORD cur_address_offset;
	DWORD Eip;
	int region_index;
	static bool warning_1 = 0;
//	HANDLE h_thread;
//	DWORD id;

//	id = thread_ids[thread_ix];
//	h_thread = h_threads[thread_ix];
// I need only EIP
//	context.ContextFlags = CONTEXT_FULL;
	context.ContextFlags = CONTEXT_CONTROL;
#if 0
// in such kind of debug, the suspending isn't needed
//	B_result = SuspendThread (h_thread);
	B_result = GetThreadContext (h_thread, &context);
//	B_result = ResumeThread (h_thread);
	if (! B_result)
	{
		if (! warning_1)
		{
			LogFile_Printf ("\n----- Warning (only once showing) in 'RegDrag_RegisterPoint_InThread ()' :  can't get thread context by thread handle %08x (id %08x) -----\n\n", h_thread, id);
			warning_1 = 1;
		}

		return 0;
	}
#endif
	result = RegDrag_ThreadContext_Get (thread_ix, &context);
	if (! result)
		return 0;

	Eip = context.Eip;
	region_index = Image_Find (Eip);

// only inside this process
	if (region_index < 0)
	{
		outside_process++;

//		c_images[region_index]->Hit (Eip);
	}
	else
	{
		inside_process++;

		c_images[region_index]->Hit (Eip);
	}

	return 1;
}

// registers numbers of eventually got addresses in process;
// keep a statistics about frequency of such events
void RegDrag_RegisterPoint ()
{
	int i;
	uint thread_ix;
//	int ix;

	total_hits++;
	if (! regdrag_register_from_threads_num)
		goto single_thread;
	if (regdrag_register_from_threads_num == -1)
// all threads
	{
		for (i = 0; i < THREADS_MAX; i++)
		{
			thread_ix = i;
			if (regdrag_is_thread_cell_in_use[thread_ix])
				RegDrag_RegisterPoint_InThread (thread_ix);
		}
		return;
	}
	Assert(regdrag_register_from_threads_num <= THREADS_MAX);
	for (i = 0; i < regdrag_register_from_threads_num; i++)
	{
		thread_ix = regdrag_register_from_threads_ixes[i];
		if (regdrag_is_thread_cell_in_use[thread_ix])
			RegDrag_RegisterPoint_InThread (thread_ix);
	}
	return;

single_thread:
	thread_ix = regdrag_register_from_thread_ix;
	if (regdrag_is_thread_cell_in_use[thread_ix])
		RegDrag_RegisterPoint_InThread (thread_ix);
	regdrag_flag__registered_thread_is_active = regdrag_is_thread_cell_in_use[thread_ix];
}

#define ERROR_BUFFER_LENGHT 256

DWORD GetError (char* buffer)
{
DWORD error;
DWORD error2;

	error = GetLastError ();

	error2 = FormatMessage (
		FORMAT_MESSAGE_FROM_SYSTEM,	// source and processing options 
		0,	// pointer to  message source 
		error,	// requested message identifier 
		0,	// language identifier for requested message 
		buffer,	// pointer to message buffer 
		ERROR_BUFFER_LENGHT,	// maximum size of message buffer 
		0 // address of array of message inserts 
		);

	return error2;
}

void RegDrag_ShowExceptionRepetitions ()
{
	if (reg_drag__exceptions_repetition_counter > 1)
		LogFile_Printf ("Exceptions at %08x repetion count is %d.\n\n", reg_drag__address_last_exception, reg_drag__exceptions_repetition_counter);
}

//bool RegDrag_Breakpoints_LoadFile (char* module_name)
bool RegDrag_Breakpoints_LoadFile (CWatchImage* c_image)
{
	BOOL B_result;
	ulong base_address;
	byte* array;
	uint size;
	HANDLE h_file;
	char* module_name;
	string file_name;
	DWORD bytes_read;
	uint num_added;

	module_name = c_image->file_name;
	base_address = c_image->image_base;
	size = c_image->image_size;
	file_name = module_name;
// breakpoints boolean mask array
	file_name += ".bpbma";
	h_file = CreateFile (file_name.c_str (), GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (h_file == INVALID_HANDLE_VALUE)
// it is normal, if file does not exist
		return 0;
	size = GetFileSize (h_file, 0);
	array = (byte*)malloc (size);
	if (! array)
	{
		LogFile_Printf ("----- RegDrag_Breakpoints_LoadFile (\"%s\") :  malloc (%08x) failed -----\n", module_name, size);
		goto close_file;
	}
	bytes_read = -1;
	B_result = ReadFile (h_file, array, size, &bytes_read, 0);
	if (! B_result)
	{
		LogFile_Printf ("----- RegDrag_Breakpoints_LoadFile (\"%s\") :  ReadFile (%08x bytes) failed -----\n", module_name, size);
		goto free_memory;
	}
	if (bytes_read != size)
	{
		LogFile_Printf ("----- RegDrag_Breakpoints_LoadFile (\"%s\") :  ReadFile (%08x bytes) has read %08x bytes instead -----\n", module_name, size, bytes_read);
		goto free_memory;
	}
	regdrag_breakpoints->AddPointsByBooleanArray (base_address, array, size, num_added);
	LogFile_Printf ("module \"%s\" :  %08x breakpoints have been added -----\n", module_name, num_added);
free_memory:
	free (array);
close_file:
	B_result = CloseHandle (h_file);
	return 1;
}

bool RegDrag_DebugEvent (DEBUG_EVENT* debug_event)
{
BOOL B_result;
DWORD D_result;
int i = 0;
static int exception_num = 0;
//char buffer[BUFFER_SIZE];
//char buffer2[BUFFER_SIZE];

bool image_load = 0;
//PSTR image_file_name;
LPVOID base_of_image = 0;
//LPVOID section_base = 0;
//SIZE_T region_size = 0;
//SIZE_T section_size = 0;
//uint code_offset = 0;
DWORD event_code = debug_event->dwDebugEventCode;
bool main_exe = 0;
HANDLE file_handle;
//HANDLE handle;
void* address = 0;
int thread_ix;
DWORD thread_id;
bool no_log_print = 0;

	switch (event_code)
	{
	case EXCEPTION_DEBUG_EVENT:
//		ProcessExceptionEvent (&debug_event);
		{
			int region_index;
			address = debug_event->u.Exception.ExceptionRecord.ExceptionAddress;

// first of all check - maybe it is our breakpoint; and don't log that then
			if (regdrag_breakpoints)
			{
				uint ix;

				if (! regdrag_breakpoints->Find ((ulong)address, ix))
					goto exception_event_continue;
// automatically disable it, since we do not support anything other atm
//				{
					regdrag_breakpoints->Disable (ix);
// also delete it
					regdrag_breakpoints->Delete (ix);
//					no_log_print = 1;
//					break;
//				}
				CONTEXT context;
// need only Eip
// CONTEXT_FULL
				context.ContextFlags = CONTEXT_CONTROL;
// again big question :  how to get any id of the maked exception thread
				RegDrag_ThreadContext_Get (0, &context);
//				context.Eip = context.Eip;
				if ((ulong)address != context.Eip - 1)
					Error ("we've failed :), the thread appears isn't this one");
// decrease by one
				context.Eip = (ulong)address;
				RegDrag_ThreadContext_Set (0, &context);

				no_log_print = 1;
				break;
			}

exception_event_continue:
			exception_num++;
			LogFile_Printf ("----- Exception debug event at %08x. -----\n", address);
			if (address == reg_drag__address_last_exception)
			{
				reg_drag__exceptions_repetition_counter++;
				goto check_exceptions_num;
			}
			RegDrag_ShowExceptionRepetitions ();
			reg_drag__exceptions_repetition_counter = 1;
			reg_drag__address_last_exception = address;
			region_index = Image_Find ((DWORD)address);
//			debug_event->u.Exception.ExceptionRecord;

//			if (region_size == -1)
//				LogFile_Printf ("\"region size\" is unknown\n");

//			if (offset >= 0/* && region_size != -1*/ && offset < region_size)
			if (region_index >= 0)
// in process region
			{
				CWatchImage* c_image = c_images[region_index];
				uint address = (uint)debug_event->u.Exception.ExceptionRecord.ExceptionAddress;
//				c_image->ShowFunction ((DWORD)debug_event->u.Exception.ExceptionRecord.ExceptionAddress);
				c_image->Exception (address);
				Displaying_ShowFunction (c_image, address - c_image->image_base);

				if (break_on_exception_inside_process)
				{
					LogFile_Printf ("Breaking on exception inside process.\n\n");
					return 0;
				}
			}
			else
			{
				if (break_on_exception_outside_process)
				{
					LogFile_Printf ("Breaking on exception outside process.\n\n");
					return 0;
				}
			}

check_exceptions_num:
			if (exception_events_max)
				if (exception_num >= exception_events_max)
				{
					LogFile_Printf ("\"exception_events_max\" (%08x) reached\n\n", exception_events_max);
					return 0;
				}
		}
		break;

	case CREATE_THREAD_DEBUG_EVENT:
		LogFile_Printf ("Debug event :  \"CREATE_THREAD_DEBUG_EVENT\"\n");
		debug_event->u.CreateThread;

		if (regdrag_reusing_thread_pointers)
// find thread cell in array, which issn't in use on this moment
		{
			for (i = 0; i < THREADS_MAX; i++)
				if (! regdrag_is_thread_cell_in_use[i])
					break;
			thread_ix = i;
		}
		else
		{
			thread_ix = regdrag_threads_num;
		}

		if (thread_ix >= THREADS_MAX)
		{
//			LogFile_Printf ("----- CREATE_THREAD_DEBUG_EVENT :  THREADS_MAX (%d) reached, quiting. -----\n", THREADS_MAX);
//			return 0;
			LogFile_Printf ("----- CREATE_THREAD_DEBUG_EVENT :  THREADS_MAX (%d) reached, skipping. -----\n", THREADS_MAX);
			break;
		}

// this var have sense only if not 'regdrag_reusing_thread_pointers'
		if (thread_ix >= regdrag_threads_num)
			regdrag_threads_num = thread_ix + 1;

		Assert(! regdrag_is_thread_cell_in_use[thread_ix]);
		thread_ids[thread_ix] = debug_event->dwThreadId;
		h_threads[thread_ix] = debug_event->u.CreateThread.hThread;
		regdrag_is_thread_cell_in_use[thread_ix] = 1;

		break;

	case CREATE_PROCESS_DEBUG_EVENT:
		LogFile_Printf ("Debug event :  \"CREATE_PROCESS_DEBUG_EVENT\"\n");
//		h_process = debug_event->u.CreateProcessInfo.hProcess;
//		h_thread = debug_event->u.CreateProcessInfo.hThread;
		D_result = (DWORD)debug_event->u.CreateProcessInfo.hProcess;

		file_handle = debug_event->u.CreateProcessInfo.hFile;
//		handle = OpenProcess (PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, d_result);
//		h_process = debug_event->u.CreateProcessInfo.hProcess;
//		GetFileNameFromHandle (h_process, buffer, BUFFER_SIZE);

// *description says, that this way will not work for all cases
//		image_file_name = (char*)debug_event->u.CreateProcessInfo.lpImageName;
//		if (image_file_name)
//			LogFile_Printf ("exe filename is \"%s\"\n", image_file_name);
//		else
//			LogFile_Printf ("exe filename is not given\n");

		base_of_image = debug_event->u.CreateProcessInfo.lpBaseOfImage;
		LogFile_Printf ("\"base of image\" is %08x\n", base_of_image);

// give all possible info, because this function may get image name by different ways
//		have_file_path = HandleFile_GetFileName (process_id, h_process, base_of_image, file_handle, (UNICODE_STRING*)buffer, BUFFER_SIZE);

		main_exe = 1;
		image_load = 1;

		process_active++;

// no CREATE_THREAD_DEBUG_EVENT and no EXIT_THREAD_DEBUG_EVENT for the main thread
		Assert(! regdrag_threads_num);
		thread_ix = regdrag_threads_num;
		thread_ids[thread_ix] = debug_event->dwThreadId;
		h_threads[thread_ix] = debug_event->u.CreateProcessInfo.hThread;
		regdrag_is_thread_cell_in_use[thread_ix] = 1;
		regdrag_threads_num++;

		break;

	case EXIT_THREAD_DEBUG_EVENT:
		LogFile_Printf ("Debug event :  \"EXIT_THREAD_DEBUG_EVENT\"\n");
		thread_id = debug_event->dwThreadId;
		for (i = 0; i < THREADS_MAX; i++)
			if (regdrag_is_thread_cell_in_use[i])
				if (thread_id == thread_ids[i])
					break;
		if (i >= THREADS_MAX)
		{
			LogFile_Printf ("----- \"EXIT_THREAD_DEBUG_EVENT\" :  thread with id %08x has not been found in array -----\n", thread_id);
			break;
		}
		thread_ix = i;
// do not clear
//		thread_ids[thread_ix] = 0;
		h_threads[thread_ix] = 0;
// this indicates that the thread does not exist
		regdrag_is_thread_cell_in_use[thread_ix] = 0;
		break;

	case EXIT_PROCESS_DEBUG_EVENT:
		LogFile_Printf ("Debug event :  \"EXIT_PROCESS_DEBUG_EVENT\"\n");
		process_active--;

		thread_ix = 0;
// do not clear
//		thread_ids[thread_ix] = 0;
		h_threads[thread_ix] = 0;
		regdrag_is_thread_cell_in_use[thread_ix] = 0;

		return 0;
//		goto finish;

	case LOAD_DLL_DEBUG_EVENT:
		LogFile_Printf ("Debug event :  \"LOAD_DLL_DEBUG_EVENT\"\n");

		file_handle = debug_event->u.LoadDll.hFile;
//		h_process = debug_event->u.LoadDll.hProcess;
//		GetFileNameFromHandle (h_process, buffer, BUFFER_SIZE);

		base_of_image = debug_event->u.LoadDll.lpBaseOfDll;
		LogFile_Printf ("\"base of image\" is %08x\n", base_of_image);

		main_exe = 0;
		image_load = 1;

		break;

	case UNLOAD_DLL_DEBUG_EVENT:
		LogFile_Printf ("Debug event :  \"UNLOAD_DLL_DEBUG_EVENT\"\n");
		break;

	case OUTPUT_DEBUG_STRING_EVENT:
		LogFile_Printf ("Debug event :  \"OUTPUT_DEBUG_STRING_EVENT\"\n");
		break;

	case RIP_EVENT:
		LogFile_Printf ("Debug event :  \"RIP_EVENT\"\n");
		break;

// ...

	default:
//		ProcessUnknownDebugEvent (&debug_event);
		break;
	}

	if (image_load)
	{
	CWatchImage* c_image;
	bool b_result;

		if (images_num >= IMAGES_MAX)
		{
			LogFile_Printf ("----- RegDrag_DebugEvent  () :  'IMAGES_MAX' hit. -----\n\n");
			return 0;
		}
		c_image = new CWatchImage;
		b_result = c_image->Init (main_exe, file_handle, base_of_image);
		c_images[images_num] = c_image;
		images_num++;
		if (! b_result)
// abort requested
		{
			LogFile_Printf ("Aborting by user request.\n");
			return 0;
		}
// breakpoints stuff
		if (regdrag_breakpoints)
//			RegDrag_Breakpoints_LoadFile (c_image->file_name);
			RegDrag_Breakpoints_LoadFile (c_image);
	}

	B_result = ContinueDebugEvent (debug_event->dwProcessId, debug_event->dwThreadId, DBG_CONTINUE);

#if 0
	d_result = GetModuleFileNameEx (h_process, (HINSTANCE)c_images[0]->base_of_image, buffer, BUFFER_SIZE);

//	if (event_code)
	if (image_load)
	{
		Sleep (2000);
		d_result = GetModuleFileNameEx (h_process, (HINSTANCE)c_images[0]->base_of_image, buffer, BUFFER_SIZE);
		d_result = GetModuleFileNameEx (h_process, (HINSTANCE)c_images[images_num - 1]->base_of_image, buffer, BUFFER_SIZE);
	}
#endif

	if (no_log_print)
		goto finish;
	if (B_result)
		LogFile_Printf ("Continue debug event.\n\n");
	else
	{
		LogFile_Printf ("----- Can't continue debug event for the process. -----\n\n");
		return 0;
	}

//	d_result = GetModuleFileNameEx (h_process, (HINSTANCE)c_images[0]->base_of_image, buffer, BUFFER_SIZE);

finish:

//	LogFile_Printf ("Debug events are handled ok.\n");

	return 1;
}

bool RegDrag_WriteResults ()
{
DWORD d_result;

	LogFile_Printf ("\n");

	if (process_active)
	{
// now - better to suspend the thread
// **that's not enough; now thread is not single
		d_result = SuspendThread (regdrag_h_thread);
		if (d_result == 0xffffffff)
		{
			LogFile_Printf ("\n----- 'RegDrag_WriteResults ()' :  The thread suspend is unsuccessful. -----\n\n");
//			return 0;
		}
	}

	RegDrag_ShowExceptionRepetitions ();
	reg_drag__exceptions_repetition_counter = 0;
	Image_ShowTotalMemoryAllocated ();

// save info to a file
	Displaying_ExportResults ();

	if (process_active)
	{
		d_result = ResumeThread (regdrag_h_thread);
		if (d_result == 0xffffffff)
		{
			LogFile_Printf ("\n----- 'RegDrag_WriteResults ()' :  The thread resume is unsuccessful. -----\n\n");
//			return 0;
		}
	}

	return 1;
}

#define FLOAT_TO_FIX_INT64(fl) ((__int64)(fl * 0x100000000))
#define DWORD_MILLISECONDS_TO_FIX_INT64(dw_ms) ((__int64)(dw_ms * 0x100000000 / 1000))
#define FIX_INT64_TO_SECONDS(fix_i64) ((int)(fix_i64 / 0x100000000))

/*
typedef struct hotkey_s
{
	char key;
	bool pressed;
} hotkey_t;
*/

bool RegDrag_Loop ()
{
	DEBUG_EVENT debug_event;
//float timer;
	__int64 timer = 0;
	int timer_seconds_last = 0;
	bool warned_1 = 0;
	bool new_mode_init;
	bool result;
	BOOL B_result;
	DWORD D_result;
// count backward
	bool timer_direction = 0;
// init with some
	ulong time_current = 0;
	ulong time_old;
	ulong time_difference;

	inside_process = 0;
	outside_process = 0;
	total_hits = 0;
	timer_registering = 0;

	registering_state = REGISTERING_STATE__PAUSE;
// *this also will ensure that 'time_old' will be set previously
	new_mode_init = 1;

	while (1)
	{
		time_old = time_current;
		double sleep_time = (registering_state == REGISTERING_STATE__REGISTERING ? sleep_time__register : sleep_time__wait);

		time_current = timeGetTime ();

// no smaller than 1ms sleep granulation is available
		if (sleep_time < 0.001)
			sleep_time = 0.001;

		timer_direction = use_timers || registering_state == REGISTERING_STATE__FINISHING;

		if (new_mode_init)
		{
			if (timer_direction)
			{
				switch (registering_state)
				{
				case REGISTERING_STATE__PAUSE:
					timer = FLOAT_TO_FIX_INT64(time_period__initializing);
					break;
				case REGISTERING_STATE__REGISTERING:
					timer = FLOAT_TO_FIX_INT64(time_period__registering);
					break;
				case REGISTERING_STATE__FINISHING:
					timer = FLOAT_TO_FIX_INT64(time_period__finishing);
					break;
				default:
					Error ("'RegDrag_Loop ()' :  wrong mode after mode switching");
				}
			}
			else
				timer = 0;

			if (registering_state == REGISTERING_STATE__FINISHING)
			{
				RegDrag_WriteResults ();

				if (! images_num)
					LogFile_Printf ("\n----- Did not got any process region information in debug events. -----\n\n");
			}

// flush taskbar icon
			timer_seconds_last = -1;
			time_difference = 0;
			new_mode_init = 0;
		}
		else
			time_difference = time_current - time_old;

// update icon - once per second
		if (timer_seconds_last != FIX_INT64_TO_SECONDS(timer))
		{
			timer_seconds_last = FIX_INT64_TO_SECONDS(timer);
			TrayIcon_Update (0, timer_seconds_last);

			char* mode_name;
			char buffer[1000];
			switch (registering_state)
			{
			case REGISTERING_STATE__PAUSE:
				mode_name = "Pause";
				break;
			case REGISTERING_STATE__REGISTERING:
				mode_name = "Registering";
				break;
			case REGISTERING_STATE__FINISHING:
				mode_name = "Finishing";
				break;
			default:
				Error ("'RegDrag_Loop ()' :  wrong mode at printing in the window");
			};
			sprintf (buffer, "Mode :  %s\r\nTime %s :  %d                    ", mode_name, (timer_direction ? "remained" : "elapsed"), timer_seconds_last);
			c_iw_thread.Text_Put (buffer);
		}

// *sleep is by 'WaitForDebugEvent ()' too
		if (WaitForDebugEvent (&debug_event, (DWORD)(1000 * sleep_time)))
		{
			if (registering_state == REGISTERING_STATE__REGISTERING && ! warned_1)
			{
				LogFile_Printf ("Warning (once) :  got debug event, at the registering time.\n\n");
				warned_1 = 1;
			}

// *error cause is printed inside
			result = RegDrag_DebugEvent (&debug_event);
// ***for the case if the process will finish itself
			if (! result)
			{
				RegDrag_WriteResults ();
				return 0;
			}

			if (events_resets_timer)
				if (registering_state == REGISTERING_STATE__PAUSE)
// *hacky a bit
					new_mode_init = 1;

			continue;
		}

// core
		switch (registering_state)
		{
		case REGISTERING_STATE__PAUSE:
			break;
		case REGISTERING_STATE__REGISTERING:
			RegDrag_RegisterPoint ();
			timer_registering += time_difference;
			break;
		case REGISTERING_STATE__FINISHING:
			B_result = GetExitCodeThread (regdrag_h_thread, &D_result);
			if (D_result != STILL_ACTIVE)
				return 1;
			break;
		default:
			Error ("'RegDrag_Loop ()' :  wrong mode");
		}

		if (timer_direction)
		{
			timer -= DWORD_MILLISECONDS_TO_FIX_INT64(time_difference);

			if (timer <= 0)
			{
				switch (registering_state)
				{
				case REGISTERING_STATE__PAUSE:
					registering_state = REGISTERING_STATE__REGISTERING;
					break;
				case REGISTERING_STATE__REGISTERING:
					registering_state = REGISTERING_STATE__FINISHING;
					break;
				case REGISTERING_STATE__FINISHING:
					LogFile_Printf ("\n----- The main thread shutdown timeout hit. -----\n\n");
					return 1;
//					break;
				default:
					Error ("'RegDrag_Loop ()' :  wrong mode after timer issue");
				}

				new_mode_init = 1;
			}
		}
		else
		{
			timer += DWORD_MILLISECONDS_TO_FIX_INT64(time_difference);
			if (registering_state == REGISTERING_STATE__FINISHING)
				if (timer >= FLOAT_TO_FIX_INT64(time_period__finishing))
					return 1;
		}

		if (hotkey_is_pressed[HOTKEY_QUIT])
		{
			hotkey_is_pressed[HOTKEY_QUIT] = 0;
			c_iw_thread.Quit ();
			return 1;
		}

		if (iw_thread__quit)
			return 1;

		if (registering_state == REGISTERING_STATE__FINISHING)
			continue;

		if (hotkey_is_pressed[HOTKEY_REGISTER])
		{
			hotkey_is_pressed[HOTKEY_REGISTER] = 0;

			if (registering_state != REGISTERING_STATE__REGISTERING)
			{
				registering_state = REGISTERING_STATE__REGISTERING;
				new_mode_init = 1;
				use_timers = 0;
			}
		}

		if (hotkey_is_pressed[HOTKEY_PAUSE])
		{
			hotkey_is_pressed[HOTKEY_PAUSE] = 0;

			if (registering_state != REGISTERING_STATE__PAUSE)
			{
				registering_state = REGISTERING_STATE__PAUSE;
				new_mode_init = 1;
				use_timers = 0;
			}
		}

		if (hotkey_is_pressed[HOTKEY_WRITE])
		{
			hotkey_is_pressed[HOTKEY_WRITE] = 0;

			RegDrag_WriteResults ();

			if (write_pauses)
			{
				registering_state = REGISTERING_STATE__PAUSE;
				new_mode_init = 1;
			}

			use_timers = 0;
		}

		if (hotkey_is_pressed[HOTKEY_EXIT])
		{
			hotkey_is_pressed[HOTKEY_EXIT] = 0;
			registering_state = REGISTERING_STATE__FINISHING;
			new_mode_init = 1;
			use_timers = 0;
		}

		if (hotkey_is_pressed[HOTKEY_CLEAR])
		{
		int i;

			hotkey_is_pressed[HOTKEY_CLEAR] = 0;

			for (i = 0; i < images_num; i++)
			{
				c_images[i]->ZeroMem ();
			}

			inside_process = 0;
			outside_process = 0;
			total_hits = 0;
			timer_registering = 0;

//			registering_state = REGISTERING_STATE__PAUSE;
//			new_mode_init = 1;
			use_timers = 0;
		}
	}
}

// *much easier to initialize such things from the function, than create static array initialization, and later have hard flexibility
void RegDrag_InitHotKeys ()
{
// *hmmm, or maybe it would better to do some structure for the 'CIWThread'
hotkey_info_t hotkey_info;

	hotkey_info.modifier = MOD_WIN;
	if (hotkeys_modifier_change)
		hotkey_info.modifier = MOD_CONTROL | MOD_ALT;
	hotkey_info.function = 0;
	hotkey_info.user_data = 0;

// *E, R, U, D, F, L, B, M with the Win key - are used by Windows XP
// [];'./ - not works

//	hotkey_info.vkey_code = 0;
//	hotkey_info.bool_ptr = &hotkey_is_pressed[HOTKEY_NONE];
// quit immediately, without writing a results
	hotkey_info.vkey_code = 'I';
	hotkey_info.bool_ptr = &hotkey_is_pressed[HOTKEY_QUIT];
	hotkey_infos[HOTKEY_QUIT] = hotkey_info;
// allow registering
	hotkey_info.vkey_code = 'A';
	hotkey_info.bool_ptr = &hotkey_is_pressed[HOTKEY_REGISTER];
	hotkey_infos[HOTKEY_REGISTER] = hotkey_info;
// pause registering
	hotkey_info.vkey_code = 'S';
	hotkey_info.bool_ptr = &hotkey_is_pressed[HOTKEY_PAUSE];
	hotkey_infos[HOTKEY_PAUSE] = hotkey_info;
// write current data
	hotkey_info.vkey_code = 'W';
	hotkey_info.bool_ptr = &hotkey_is_pressed[HOTKEY_WRITE];
	hotkey_infos[HOTKEY_WRITE] = hotkey_info;
// begin exit sequence
	hotkey_info.vkey_code = 'Q';
// *key is in use
	if (hotkeys_modifier_change)
		hotkey_info.vkey_code = 'E';
	hotkey_info.bool_ptr = &hotkey_is_pressed[HOTKEY_EXIT];
	hotkey_infos[HOTKEY_EXIT] = hotkey_info;
// clear all registered data
	hotkey_info.vkey_code = 'T';
// test
//	hotkey_info.vkey_code = 'B';
// *key is in use
	if (hotkeys_modifier_change)
		hotkey_info.vkey_code = 'Y';
	hotkey_info.bool_ptr = &hotkey_is_pressed[HOTKEY_CLEAR];
	hotkey_infos[HOTKEY_CLEAR] = hotkey_info;

	c_iw_thread.SetHotKeysData (hotkey_infos, HOTKEYS_NUM);
}

// *because of "ntoskrnl.lib"
char* Strchr (char* string, char search_char)
{
	while (string)
	{
		if (*string == search_char)
			break;
		string++;
	}

	if (*string == search_char)
		return string;
	else
		return 0;
}

// bite a bit from string :); until a separator, and then remove that piece from the string
inline void strbite (string& str_bit, string& str_in, const char* delimiters_list = "\t\n\r ,./:;")
{
	int i;
	i = str_in.find_first_of(delimiters_list);
	if (i == string::npos)
// no (more) delimiter found
	{
		str_bit = str_in;
		str_in.erase();
		return;
	}
	str_bit = str_in.substr (0, i);
	str_in.erase(0, i + 1);
}

// *always display all known threads info
void RegDrag_PrintThreadInfos (string& str)
{
	int i;
	string s;
//	string str;
	stringstream strm;
	uint thread_ix;
//	bool by_ixes_list;
//	uint end;
	uint id;
	bool some_printed;

	some_printed = 0;
//	Assert(regdrag_register_from_threads_num);
//	by_ixes_list = regdrag_register_from_threads_num != -1;
//	Assert(! by_ixes_list || regdrag_register_from_threads_num <= THREADS_MAX);
//	end = by_ixes_list ? regdrag_register_from_threads_num : THREADS_MAX;
//	for (i = 0; i < end; i++)
	for (i = 0; i < THREADS_MAX; i++)
	{
//		if (by_ixes_list)
//			thread_ix = regdrag_register_from_threads_ixes[i];
//		else
			thread_ix = i;
//		Assert(thread_ix < THREADS_MAX);
// these already are cleared
//		if (! regdrag_is_thread_cell_in_use[thread_ix])
//			continue;
		id = thread_ids[thread_ix];
		if (! id)
			continue;
//		if (i)
		if (some_printed)
			str.append("; ");
//			strm << "; ";
// clear stream contains
		strm.str("");
// ix
		strm.clear();
		strm.unsetf (ios::hex);
		strm.setf (ios::dec);
		strm << thread_ix;
		strm << ", ";
// id
		strm.clear();
		strm.unsetf (ios::dec);
		strm.setf (ios::hex);
		strm << id;
//		strm << ".";

//		strm >> s;
		s = strm.str();
		str.append(s);
		some_printed = 1;
	}
}

// some of settings needs to be additionally parsed
void RegDrag_InitSettings ()
{
	int i_result;
	int i;
	string str;
	stringstream strm;
	string s;
	uint ix;

	i = 0;
	regdrag_register_from_threads_num = 0;
	str = regdrag_register_from_threads_str;
//	strm << regdrag_register_from_threads_str;
	i_result = str.compare ("-");
	if (! i_result)
// all threads chosen
	{
		regdrag_register_from_threads_num = -1;
		goto finish;
	}
loop:
//	strm >> s;
	strbite(s, str);
	if (s.empty())
	{
		regdrag_register_from_threads_num = i;
		goto finish;
	}
	if (i >= THREADS_MAX)
		Error ("RegDrag_InitSettings () :  cannot parse threads' indices; THREADS_MAX (%d) reached", THREADS_MAX);
//	strm.str("");
	strm.clear();
	strm << s;
	strm >> ix;
	if (strm.fail())
		Error ("RegDrag_InitSettings () :  string \"%s\" cannot be scanned as a thread's index", s.c_str());
	if (! strm.eof())
		Error ("RegDrag_InitSettings () :  string \"%s\" cannot be scanned as a thread's index, it is soiled", s.c_str());
	if (ix >= THREADS_MAX)
		Error ("RegDrag_InitSettings () :  thread index value (%u) is too high; greater than THREADS_MAX (%u)", ix, THREADS_MAX);
	regdrag_register_from_threads_ixes[i] = ix;
	i++;
	goto loop;
finish:
	;
}

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	bool result;
	char* c_result;
	BOOL B_result;
	DWORD D_result;
	PROCESS_INFORMATION process_information;
	STARTUPINFO startupinfo;
//	MEMORY_BASIC_INFORMATION memory_basic_information;
// - errors -
//	byte error_message[ERROR_BUFFER_LENGHT];
//	PIMAGE_DEBUG_INFORMATION pimage_debug_information;
//	char temp[PATH_BUFFER_SIZE];
//	int process_executable_path_is_given = 0;
	int i;
//	int j;
	OSVERSIONINFO ver;
	MMRESULT mmresult;
	UINT timer_period;
	HANDLE handle_process_self;
	DWORD id;

// test
#if 0
//	iostream strm;
	stringstream strm;
	uint ui;
	strm << "";
	strm >> ui;
	result = strm.good ();
	result = strm.fail ();
	result = strm.eof ();
	return 0;
#endif

// test
//	_snprintf (regdrag_dir_watcher_executable, sizeof(regdrag_dir_watcher_executable) - 1, "%03.2x", 0xa);

	ver.dwOSVersionInfoSize = sizeof(ver);
	::GetVersionEx (&ver);
	if ((ver.dwPlatformId == VER_PLATFORM_WIN32_NT) && (ver.dwMajorVersion >= 5))
		at_least_Win2K = 1;
	HandleFile_InitFunctions ();
	CFileNT_Init ();

	Args_ParseCmdLine (lpCmdLine);
	RegDrag_InitSettings ();

	RegDrag_InitHotKeys ();

	c_iw_thread.Init (hInstance);
	c_iw_thread.Text_Put ("World ! Hello !!!!!");
//	while (! quit)
//		Sleep (1000);

//*there will be no (will be maked to "C:\") current directory, if will be specified (given) full path in command line (or maybe when drag and dropped)
// , so, restore watcher's working directory
//	B_result = GetCurrentDirectory(256,watcher_dir);
	B_result = GetModuleFileName (0, regdrag_dir_watcher_executable, sizeof(regdrag_dir_watcher_executable));
// finish at last backslash
	if (c_result = strrchr (regdrag_dir_watcher_executable, '\\'))
		*c_result = 0;
	B_result = SetCurrentDirectory (regdrag_dir_watcher_executable);

// now, after 'SetCurrentDirectory ()' we can clear log file
	LogFile_Clear ();

	LogFile_Printf ("Current directory  : \"%s\".\n", regdrag_dir_watcher_executable);
	LogFile_Printf ("Command line  : \"%s\".\n", lpCmdLine);
/*
	DWORD GetFullPathName(

    LPCTSTR lpFileName,	// address of name of file to find path for 
    DWORD nBufferLength,	// size, in characters, of path buffer 
    LPTSTR lpBuffer,	// address of path buffer 
    LPTSTR *lpFilePart 	// address of filename in path 
   );
*/

// == watcher working directory ==
	if (regdrag_dir_watcher_working_arg)
// got directory
		Strncpy (regdrag_dir_watcher_working, regdrag_dir_watcher_working_arg, sizeof(regdrag_dir_watcher_working));
	else
// use directory of executable
		Strncpy (regdrag_dir_watcher_working, regdrag_dir_watcher_executable, sizeof(regdrag_dir_watcher_working));

// == process executable directory, path and name ==
// find out process executable path
// find out process executable directory, and get pointer to name
	if (regdrag_dir_process_exe_arg)
	{
//		Strncpy (regdrag_process_executable_path, regdrag_dir_process_exe_arg, sizeof(regdrag_process_executable_path));
		regdrag_str_process_executable_path = regdrag_dir_process_exe_arg;
		Strncpy (regdrag_dir_process_executable, regdrag_dir_process_exe_arg, sizeof(regdrag_dir_process_executable));
	}
	else
	{
//		regdrag_process_executable_path[0] = 0;
		regdrag_str_process_executable_path.empty ();
		regdrag_dir_process_executable[0] = '\0';
	}
#if 0
	Strncpy (regdrag_process_executable_path, regdrag_process_cmdline, sizeof(regdrag_process_executable_path));
// finish at first space
	if (c_result = Strchr (regdrag_process_executable_path, ' '))
		*c_result = 0;
#endif
#if 0
	strcat (regdrag_process_executable_path, "\\");
	i = strlen (regdrag_process_executable_path);
	j = 0;
	while (1)
	{
		if (i >= sizeof(regdrag_process_executable_path))
		{
			LogFile_Printf ("\n----- 'regdrag_process_executable_path' buffer overflow. -----\n\n");
			goto finish;
		}
		if (! regdrag_process_executable_file_name[j])
			break;
		regdrag_process_executable_path[i] = regdrag_process_executable_file_name[j];
		i++;
		j++;
	}
#endif
	regdrag_str_process_executable_path += '\\';
	regdrag_str_process_executable_path += regdrag_process_executable_file_name;
	regdrag_str_process_cmdline = '"';
//	regdrag_str_process_cmdline += regdrag_process_executable_file_name;
	regdrag_str_process_cmdline += regdrag_str_process_executable_path;
	regdrag_str_process_cmdline += '"';
	if (regdrag_process_args_arg)
	{
		regdrag_str_process_cmdline += ' ';
		regdrag_str_process_cmdline += regdrag_process_args_arg;
	}
// by some cause, 'CreateProcess ()' needs the command line string, where the new process can write
	Strncpy (regdrag_process_cmdline, regdrag_str_process_cmdline.c_str (), sizeof(regdrag_process_cmdline));
#if 0
// find out process executable directory, and get pointer to name
	Strncpy (regdrag_dir_process_executable, regdrag_process_executable_path, sizeof(regdrag_dir_process_executable));
	if (c_result = strrchr (regdrag_dir_process_executable, '\\'))
// the path is given
		*c_result++ = 0;
	else
// no path
	{
		regdrag_dir_process_executable[0] = '\0';
		c_result = regdrag_process_executable_path;
	}
#endif
// pointer to name has been got
// what pointer ? :), seems long time outdated comment
//	Strncpy (regdrag_process_executable_file_name, c_result, sizeof(regdrag_process_executable_file_name));

// - process working directory -
	if (regdrag_dir_process_working_arg)
// got directory
		Strncpy (regdrag_dir_process_working, regdrag_dir_process_working_arg, sizeof(regdrag_dir_process_working));
	else
// no directory specified in process command line
// try to find out working directory of watching process
	{
		if (c_result = Strchr (regdrag_dir_process_executable, ':'))
			Strncpy (regdrag_dir_process_working, regdrag_dir_process_executable, sizeof(regdrag_dir_process_working));
		else
// use current watcher working directory
			Strncpy (regdrag_dir_process_working, regdrag_dir_watcher_working, sizeof(regdrag_dir_process_working));
	}

// == breakpoints init ==
	if (regdrag_breakpoints_allocate_num)
		regdrag_breakpoints = new BreakPoints (regdrag_breakpoints_allocate_num);

// == multimedia timer ==
// set new time period for multimedia timer; mostly intended to shorten task switching time; default is 10ms
	timer_period = UINT(multimedia_timer_period * 1000.0);
// limit at 1 second value
#define TIMER_PERIOD_MAX 1000
	if (timer_period > TIMER_PERIOD_MAX)
	{
		LogFile_Printf ("warning :  requested to set multimedia timer period to %u, limiting at %u\n", timer_period, TIMER_PERIOD_MAX);
		LogFile_Printf ("\n");
		timer_period = TIMER_PERIOD_MAX;
	}
	if (timer_period)
	{
		mmresult = timeBeginPeriod (timer_period);
		if (mmresult != TIMERR_NOERROR)
		{
			LogFile_Printf ("----- warning :  timeBeginPeriod (%u) fail -----\n", timer_period);
			LogFile_Printf ("\n");
		}
	}

// == create the process ==
// *for what to get own info ?
	GetStartupInfo (&startupinfo);

// don't press F10 (Step Over) on it :)
	B_result = CreateProcess
	(
// pointer to name of executable module
//		0,
// *must have path, if current directory not shows the path right
// *cannot contain arguments
		regdrag_str_process_executable_path.c_str (),	
// pointer to command line string
// *is used for arguments
		regdrag_process_cmdline,
// pointer to process security attributes
//		LPSECURITY_ATTRIBUTES lpProcessAttributes,
		0,
// pointer to thread security attributes
//		LPSECURITY_ATTRIBUTES lpThreadAttributes,
		0,
// handle inheritance flag
//		BOOL bInheritHandles,
		0,
// creation flags
		DEBUG_PROCESS,
// pointer to new environment block
//		LPVOID lpEnvironment,
		0,
// pointer to current directory name
		regdrag_dir_process_working,
// pointer to STARTUPINFO
		&startupinfo,
// pointer to PROCESS_INFORMATION
		&process_information
	);

// *return back for the log file
//	B_result = SetCurrentDirectory (watcher_dir);

	if (B_result)
		LogFile_Printf ("Process \"%s\" created successfully.\n", regdrag_str_process_executable_path.c_str ());
	else
	{
		LogFile_Printf ("Can't create process for :  \"%s\".\n", regdrag_str_process_executable_path.c_str ());
		return -1;
	}

// == own process handle ==
// *seems this function cannot fail
	id = GetCurrentProcessId ();
	handle_process_self = OpenProcess (PROCESS_ALL_ACCESS, 0, id);
	if (! handle_process_self)
	{
		LogFile_Printf ("----- Can't get own process handle -----\n");
//		return;
	}

	regdrag_h_process = process_information.hProcess;
	regdrag_h_thread = process_information.hThread;
	process_id = process_information.dwProcessId;

	if (handle_process_self)
	{
		result = ProcessPriority_Set (handle_process_self, "Drag Watcher", process_priority__watcher);
	}
	result = ProcessPriority_Set (regdrag_h_process, "EXE", process_priority__exe);

	if (regdrag_breakpoints)
		regdrag_breakpoints->SetHandleProcess (regdrag_h_process);

// wait for debug events, and make a beginning pause at the same time
//	if (! WaitDebugEvents ())
// *error cause is printed inside
//		goto finish;

//	RetrieveFileNames ();

// check before 'VirtualQuery ()'
	B_result = GetExitCodeThread (regdrag_h_thread, &D_result);
	if (D_result != STILL_ACTIVE)
	{
		LogFile_Printf ("\n----- The main thread isn't active. -----\n\n");
		goto finish;
	}

	LogFile_Printf ("\n");

// main watcher's loop
	RegDrag_Loop ();

	LogFile_Printf ("\n");

	if (timer_period)
	{
		mmresult = timeEndPeriod (timer_period);
		if (mmresult != TIMERR_NOERROR)
		{
			LogFile_Printf ("----- warning :  timeEndPeriod (%u) fail -----\n", timer_period);
			LogFile_Printf ("\n");
		}
	}

// == breakpoints quit ==
	if (regdrag_breakpoints)
	{
		regdrag_breakpoints->DumpRemained_ToLog (1);
		delete regdrag_breakpoints;
		regdrag_breakpoints = 0;
	}

//	free (registration_array);
// deleting of all 'CWatchImage'
	for (i = 0; i < images_num; i++)
	{
		c_images[i]->Quit ();
		delete c_images[i];
	}

finish:
//	if (compile_info_path)
//		free (compile_info_path);

//	__asm int 1
	if (regdrag_h_process)
		B_result = TerminateProcess (regdrag_h_process, 0);
//		B_result = TerminateProcess (process_information.hProcess,0);

	if (! B_result)
		LogFile_Printf ("----- The process (%08x) has not been terminated. -----\n", regdrag_h_process);

//	ExitProcess (0);

//	LogFile_Printf ("Finished successfully.\n");
	LogFile_Printf ("\nFinished.\n");

	c_iw_thread.Quit ();

return 0;
}

