// by Alexander Ilyin


#pragma once

#include <windows.h>
#include "types.h"
#include "image.h"
#include "settings.h"
#include <string>
using namespace std;


#define WINAPP_NAME "Drag Watcher"


// +++ settings +++
// + periods +
// gives the process time, to initialize itself
extern double time_period__initializing;
extern double time_period__registering;
extern double time_period__finishing;
// - periods -
// + sleeps +
// OS multitasking manager time chunk
extern double multimedia_timer_period;
// which period to sleep (sec)
extern double sleep_time__wait;
extern double sleep_time__register;
// - sleeps -
extern int break_on_exception_inside_process;
extern int break_on_exception_outside_process;
extern int events_resets_timer;
extern int exception_events_max;
//extern bool read_map_files;
extern bool read_map_main_exe;
extern bool read_map_loaded_dlls;
extern bool use_timers;
extern bool write_pauses;
extern bool clear_pauses;
// + multithread +
//extern bool regdrag_register_from_all_threads;
extern uint regdrag_register_from_thread_ix;
extern bool regdrag_reusing_thread_pointers;
extern char* regdrag_register_from_threads_str;
//extern uint regdrag_register_from_threads_ixes[];
extern uint regdrag_register_from_threads_num;
extern bool regdrag_threads_suspend;
// - multithread -
// + breakpoints +
extern uint regdrag_breakpoints_allocate_num;
// - breakpoints -
// + hotkeys +
extern bool hotkeys_modifier_change;
// - hotkeys -
// --- settings ---

// +++ directories +++
extern char* regdrag_dir_watcher_working_arg;
extern char* regdrag_dir_process_exe_arg;
extern char* regdrag_dir_process_working_arg;
extern char regdrag_dir_process_executable[PATH_BUFFER_SIZE];
// --- directories ---

// +++ debugging thread parameters +++
extern char regdrag_process_executable_file_name[PATH_BUFFER_SIZE];
extern char* regdrag_process_args_arg;
//extern char regdrag_process_args[PATH_BUFFER_SIZE];
//extern char regdrag_process_executable_path[PATH_BUFFER_SIZE];
//extern char regdrag_process_cmdline[PATH_BUFFER_SIZE];
// --- debugging thread parameters ---

// +++ debugging thread parameters +++
extern HANDLE regdrag_h_process;
// --- debugging thread parameters ---
// +++ process memory +++
extern CWatchImage* c_images[];
extern int images_num;
// --- process memory ---

// +++ registering +++
extern __int64 inside_process;
extern __int64 outside_process;
extern __int64 total_hits;
extern int timer_registering;
// --- registering ---

// +++ work/displayable +++
extern bool at_least_Win2K;
// --- work/displayable ---

// +++ process priority +++
extern int process_priority__watcher;
extern int process_priority__exe;
// --- process priority ---


void RegDrag_PrintThreadInfos (string& str);

