// by Alexander Ilyin

#pragma once

#include "map_file.h"
#include "image.h"


typedef struct
{
	int image_index;
	__int64 hits_num;
} module_info_t;

typedef struct
{
	int image_index;
	uint address;
	uint hits_number;
} point_info_t;

typedef struct
{
	int image_index;
	uint start; // start of block
	uint mostly; // mostly draging point
	uint end; // end of block
	__int64 number; // total number
// *not looks as necessary, but may appear helpful (maybe because of simplification at display time)
	uint number_for_mostly; // number for mostly dragging point
} block_info_t;

typedef struct
{
//	int image_index;
	CWatchImage* c_image;
//	int section_index;
// + internal +
	int function_index;
// - internal -
	map_file_function_info_t* map_file_function_info;
// mostly draging point
	uint offset_mostly;
// total number
	__int64 number;
// number for mostly dragging point
	uint number_for_mostly;
} function_info_t;


// -- settings --
extern uint distance_unite;

extern module_info_t modules[];
extern point_info_t* points;
extern int num_points;
extern block_info_t* blocks;
extern int num_blocks;
extern function_info_t* functions;
extern int num_functions;


extern void Sorting_ByModules (void);
extern void Sorting_ByPoints (void);
extern void Sorting_ByBlocks (void);
extern void Sorting_ByFunctions (void);
