#pragma once

// by Alexander Ilyin
// *original belongs at the Dragging Watcher project

#include "config.h"
// 'Vsnprintf ()'
#if ! defined (OWN_VSNPRINTF)
// on by default
#define OWN_VSNPRINTF 1
#endif
#include "types.h"
// when own 'Vsnprintf ()', it is instead of libc; and more libc subroutines will be replaced also.
#if OWN_VSNPRINTF
#include <stdarg.h>
#else
#include <stdio.h>
#endif


uint Strlen (const char* str);
bool Strncpy (char* dest, const char* src, uint buffer_size);
bool Strcpy (char* dest, const char* src);
bool WStrncpy (wchar_t* dest, const wchar_t* src, uint buffer_size);
bool Strncat (char* dest, char* src, uint buffer_size);
bool Strcat (char* dest, char* src);
// copy, and return 0, if it is not alphanum or does not fit into buffer
bool Str_IsAlphaNum (const char* str);
// insert one char in a string in sized buffer
bool StringN_InsertChar (char* string, uint string_buffer_size, char char_insert, uint position);
// delete one char, to the left from the position
bool String_BackspaceChar (char* string, uint position);
// delete one char, on the position
bool String_DeleteChar (char* string, uint position);
// convert Unicode string to ANSI format
bool String_UnicodeToANSI (char* ansi_string, int buffer_size, ushort* unicode_string, int string_size);

#if OWN_VSNPRINTF
bool SNPrintf (char* buffer, uint buffer_size, uint* symbols_written, const char* format, ...);
bool Snprintf (char* buffer, uint buffer_size, const char* format, ...);
int SNPrintF (char* buffer, uint buffer_size, const char* format, ...);
bool Vsprintf (char* buffer, uint* symbols_written, const char* format, va_list argptr);
bool SPrintf (char* buffer, uint* symbols_written, const char* format, ...);
bool Sprintf (char* buffer, const char* format, ...);
int SPrintF (char* buffer, const char* format, ...);

// make things simplier to use :)
#define STRCPY(_out_, _in_) Strncpy (_out_, _in_, sizeof(_out_))
#define SPRINTF(_out_, _fmt_, ...) Snprintf (_out_, sizeof(_out_), _fmt_, __VA_ARGS__)
//#define SPRINTF(_out_, ...) Snprintf (_out_, sizeof(_out_), __VA_ARGS__)
#endif

