// by Alexander Ilyin
// indicating icon on the system tray
// *taken from RAMpage (Based on system tray example Tray42 by Michael T. Smith)
// *original belongs at the Drag Watcher project

#include <windows.h>
#include<assert.h>

#include "types.h"


#define UWM_SYSTRAY (WM_USER + 1) // Sent to us by the systray

int show_tray_icon = 0;

const char classname[] = "Drag Watcher"; // Window class name


#define FONT_WIDTH (sizeof(byte) * 8)
#define FONT_HEIGHT 8

// * closer to "verdana"
const BYTE Numbers_normal[10][FONT_HEIGHT] = 
{
// "0" Bitmap
	{0x38,0x44,0x44,0x44,0x44,0x44,0x44,0x38},
// "1" Bitmap
	{0x10,0x70,0x10,0x10,0x10,0x10,0x10,0x7c},
// "2" Bitmap
	{0x38,0x44,0x04,0x08,0x10,0x20,0x40,0x7c},
// "3" Bitmap
	{0x38,0x44,0x04,0x18,0x04,0x04,0x44,0x38},
// "4" Bitmap
	{0x08,0x18,0x28,0x48,0x88,0xfc,0x08,0x08},
// "5" Bitmap
	{0x7c,0x40,0x40,0x78,0x04,0x04,0x44,0x38},
// "6" Bitmap
	{0x18,0x20,0x40,0x78,0x44,0x44,0x44,0x38},
// "7" Bitmap
	{0x7c,0x04,0x08,0x08,0x10,0x10,0x20,0x20},
// "8" Bitmap
	{0x38,0x44,0x44,0x38,0x44,0x44,0x44,0x38},
// "9" Bitmap
	{0x38,0x44,0x44,0x44,0x3c,0x04,0x08,0x30},
};

const BYTE Letters_normal[26][FONT_HEIGHT] = 
{
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "F" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "H" Bitmap
	{0x82,0x82,0x82,0xfe,0x82,0x82,0x82,0x82},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "M" Bitmap
	{0x82,0xc6,0xaa,0x92,0x82,0x82,0x82,0x82},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "R" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "A" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
// "Z" Bitmap
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
};


typedef struct
{
	byte b,g,r;
} bgr8;

#define ICON_WIDTH 16
#define ICON_HEIGHT 16
#define ICON_BYTES_NUM (ICON_WIDTH * ICON_HEIGHT)
#define MASK_BYTES_NUM (ICON_BYTES_NUM / 8)


bgr8 gray_grid16[ICON_BYTES_NUM] = 
{
	{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},
	{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},
	{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},
	{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},
	{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},
	{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},
	{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},
	{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},
	{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},{0,0,0},{0xff,0xff,0xff},
};

bgr8 gray_grid8[ICON_BYTES_NUM] = 
{
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},
	{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},
	{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},
	{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},
	{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},
};

bgr8 gray_grid4[ICON_BYTES_NUM] = 
{
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},
	{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},
	{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},
	{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},
	{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},{0xff,0xff,0xff},
};

bgr8 icon_bitmap_background[ICON_BYTES_NUM];
bgr8 icon_bitmap[ICON_BYTES_NUM];
bgr8 icon_bitmap_mask[ICON_BYTES_NUM];


//LRESULT CALLBACK wndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
NOTIFYICONDATA nid;


extern void TrayIcon_Delete (void);

void TrayIcon_Initialize ()
{
	nid.cbSize = sizeof(NOTIFYICONDATA); // size
	nid.hWnd = NULL;//ghWnd; // window to receive notifications
	nid.uID = 1;      // application-defined ID for icon (can be any UINT value)
	nid.szTip[63] = '\0';  // guarantee that the tooltip is null terminated.

}

void TrayIcon_Print (bgr8* icon_bmp,int offset_x,int offset_y,byte symbol)
{
//bgr8(* icon_bmp)[ICON_HEIGHT][ICON_WIDTH] = icon_bmp_ptr;
int x,y;
int pos_x,pos_y;
int bits;

	assert(offset_x >= 0 && offset_x <= (ICON_WIDTH - FONT_WIDTH));
	assert(offset_y >= 0 && offset_y <= (ICON_HEIGHT - FONT_HEIGHT));

	for (y = 0;y < FONT_HEIGHT;y++)
	{
		if (symbol >= '0' && symbol <= '9')
			bits = Numbers_normal[symbol - '0'][y];
		else if (symbol >= 'A' && symbol <= 'Z')
			bits = Letters_normal[symbol - 'A'][y];

		pos_y = offset_y + y;

		for (x = 0;x < FONT_WIDTH;x++)
		{
			if (bits & 0x80)
			{
				pos_x = offset_x + x;

/*
				icon_bmp[pos_y][pos_x].r = 0xff;
				icon_bmp[pos_y][pos_x].g = 0xff;
				icon_bmp[pos_y][pos_x].b = 0xff;
*/
			int index = pos_y * ICON_WIDTH + pos_x;

				icon_bmp[index].r = 0xff;
				icon_bmp[index].g = 0xff;
				icon_bmp[index].b = 0xff;
			}

			bits <<= 1;
		}
	}
}

void TrayIcon_PrintThreeSymbols (bgr8* icon_bmp,byte symb0,byte symb1,byte symb2)
{
int x,y;

	x = symb0 && symb1 ? 1 : 5;
	y = symb2 ? 0 : 4;

	if (symb0)
	{
		TrayIcon_Print (icon_bmp,x,y,symb0);
		x += 7;
	}

	if (symb1)
		TrayIcon_Print (icon_bmp,x,y,symb1);

	y += 8;

	if (symb2)
		TrayIcon_Print (icon_bmp,5,y,symb2);
}

void TrayIcon_PrintTime (bgr8* icon_bmp,int time)
{
// 0 - seconds, 1 - minutes, 2 - hours
int time_units = 0;
byte symbol0,symbol1;
byte symbol2 = 0;

//	assert(time < 60 * 60 * 24 * 100);

	if (time >= 100)
// get minutes
	{
		time /= 60;
		time_units++;
		symbol2 = 'M';
	}

	if (time >= 100)
// get hours
	{
		time /= 60;
		time_units++;
		symbol2 = 'H';
	}

	if (time >= 100)
// get days
	{
		time /= 24;
		time_units++;
		symbol2 = 'D';
	}

	if (time >= 100)
// too much
	{
		symbol0 = '^';
		symbol1 = '^';
//		symbol2 = 'D';
	}
	else
// in range
	{
		symbol0 = time / 10 + '0';
		symbol1 = time % 10 + '0';
		if (symbol0 == '0')
			symbol0 = 0;
	}

// print symbols
	TrayIcon_PrintThreeSymbols (icon_bmp,symbol0,symbol1,symbol2);
}

// Updates the icon in the System Tray
void TrayIcon_Update (int type,int time)
{
//HDC hdc;
static HBITMAP hBitmap;
static HBITMAP hBitmap_mask;
ICONINFO iconinfo;
static int first_time = 1;
// view (color) of icon
static int icon_type = -1; // not valid
//HWND hWnd;
bgr8 color;
int i;
// initialzed by zeroes
static byte mask[MASK_BYTES_NUM];

	if (! show_tray_icon)
		return;

	if (first_time)	// Initializing - Add the sys tray icon
	{
		TrayIcon_Initialize ();
//		memcpy(nid.szTip,classname,63); // Copying some extra garbage here - but no harm done
//		first_time = 0;
	}
//	else
//		memcpy(nid.szTip,IconBitmap+128,63);	// Copying some extra garbage here - but no harm done

	if (icon_type != type)
// type changed - create icon bitmap anew
	{
		icon_type = type;

		switch (icon_type)
		{
		case 0:
			color.r = 0xa0; color.g = 0; color.b = 0;
			break;
		case 1:
			color.r = 0x00; color.g = 0xa0; color.b = 0;
			break;
		}

		for (i = 0;i < ICON_BYTES_NUM;i++)
		{
			icon_bitmap_background[i].r = gray_grid4[i].r & color.r;
			icon_bitmap_background[i].g = gray_grid4[i].g & color.g;
			icon_bitmap_background[i].b = gray_grid4[i].b & color.b;
		}

		for (i = 0;i < MASK_BYTES_NUM;i++)
		{
			mask[i] = 0;
		}
	}

// copy background first
	for (i = 0;i < ICON_BYTES_NUM;i++)
	{
		icon_bitmap[i] = icon_bitmap_background[i];
	}

// copy mask
	for (i = 0;i < MASK_BYTES_NUM;i++)
	{
		((byte *)icon_bitmap_mask)[i] = mask[i];
	}

//	bgr8(* icon_bmp_ptr)[ICON_HEIGHT][ICON_WIDTH] = (bgr8*)icon_bitmap;
// print time
	TrayIcon_PrintTime ((bgr8 *)icon_bitmap,time);

	hBitmap = CreateBitmap (ICON_WIDTH,ICON_HEIGHT,1,24,icon_bitmap);
// *bpp doesn't matter
	hBitmap_mask = CreateBitmap (ICON_WIDTH,ICON_HEIGHT,1,24,icon_bitmap_mask);

	if ((hBitmap != NULL) && (hBitmap_mask != NULL))
	{
		iconinfo.fIcon = 1;
		iconinfo.xHotspot = 0; 
		iconinfo.yHotspot = 0; 
		iconinfo.hbmMask = hBitmap_mask;
		iconinfo.hbmColor = hBitmap; 
		nid.hIcon = CreateIconIndirect (&iconinfo);
	}
	else
		nid.hIcon = NULL;

	if (hBitmap != NULL)
		DeleteObject (hBitmap);
	if (hBitmap_mask != NULL)
		DeleteObject (hBitmap_mask);

	if (first_time)	// Initializing - Add the sys tray icon
	{
//		memcpy(nid.szTip,/*classname*/"prb",63); // Copying some extra garbage here - but no harm done
		strcpy (nid.szTip, "Dragging Watcher");
		nid.uFlags = //NIF_MESSAGE |	// nid.uCallbackMessage is valid, use it
					NIF_ICON |		// nid.hIcon is valid, use it
					NIF_TIP;		// nid.szTip is valid, use it
		nid.uCallbackMessage = UWM_SYSTRAY; // message sent to nid.hWnd
		Shell_NotifyIcon (NIM_ADD,&nid);
		atexit(TrayIcon_Delete);
		first_time = 0;
	}
	else					// Updating - Modify the sys tray icon
    {
		nid.uFlags = NIF_ICON | NIF_TIP; 
		Shell_NotifyIcon (NIM_MODIFY,&nid);
	}

	if (nid.hIcon != NULL)
		DestroyIcon (nid.hIcon);

//	TrayIcon_Delete ();
}

void TrayIcon_Delete (void)
{
//NOTIFYICONDATA nid;

/*
	nid.cbSize = sizeof(NOTIFYICONDATA); // size
	nid.hWnd = NULL;//ghWnd; // window to receive notifications
	nid.uID = 1;      // application-defined ID for icon (can be any UINT value)
*/
	Shell_NotifyIcon (NIM_DELETE,&nid);
}

