// by Alexander Ilyin
// loading and getting of module info from .map file
// *currently - only for functions' info
// *original belongs at the Dragging Watcher project
// *.map file is not for program read and is for human read and have no info about sections' offsets,
// so, the standalone map file is not valid for real debug/watch, need to read sections info from exe also

//#include <windows.h>
#include <stdlib.h>

#include "map_file.h"
#include "log_file.h"
#include "reg_drag.h"
#include "string.h"
#include "error.h"
#include "file_nt.h"
#include "XMessageBox.h"


static bool mapfile__skip_all__not_found = 0;
static bool mapfile__skip_all__not_suitable = 0;
static bool mapfile__skip_all__broken = 0;


CMapFile::CMapFile ()
{
//	map_file_function_infos = NULL;
	function_names_buffer = NULL;

//	functions_info_buffer_size = 0;
//	number_of_functions = 0;
	size_of_names_buffer = 0;
	current_index_in_names_buffer = 0;

	memset (section_infos, 0, sizeof(section_infos));

//	not_decompiled_strings_num = 0;

//	beginning_addresses = NULL;
//	function_names = NULL;
//	obj_names = NULL;
}

// this function can't be outside
void CMapFile::PromptSkip (char* text, bool* flag__skip_all, bool* no)
{
int mb_result;

//	mb_result = MessageBox (NULL, text, NULL, MB_YESNO);
	mb_result = XMessageBox (NULL, text, NULL, MB_YESNO | MB_YESTOALL, NULL);
	if (mb_result == IDNO)
		*no = 1;
	if (mb_result == IDYESTOALL)
		*flag__skip_all = 1;
}

#define STRING_BUFFER_SIZE 256
#define GETS_BUFFER_SIZE 1024

bool CMapFile::Init (wchar_t* exe_file_path, char* module_file_name, section_t* sections, int sections_num)
{
bool result;
wchar_t* wc_file_path = (wchar_t*)file_path;
wchar_t* wc_ptr;
int buffer_size;

	Strncpy (module_name, module_file_name, FILE_NAME_MAX);

// copy and change extension
	result = WStrncpy (wc_file_path, exe_file_path, sizeof(file_path));
	if (! result)
	{
		Error ("'CMapFile::Init ()' :  can't copy file path");
		return 0;
	}
	wc_ptr = wcsrchr (wc_file_path, L'.');
	if (! wc_ptr)
	{
		Error ("'CMapFile::Init ()' :  can't find extension");
		return 0;
	}
	wc_ptr++;
	buffer_size = sizeof(file_path);
	buffer_size -= (byte*)wc_ptr - (byte*)wc_file_path;
	result = WStrncpy (wc_ptr, L"map", buffer_size);
	if (! result)
	{
		Error ("'CMapFile::Init ()' :  can't append extension");
		return 0;
	}
	image_sections = sections;
	image_sections_num = sections_num;

	return 1;
}

// returns "file loaded"
//bool CMapFile::LoadFile (char* name, char* directory, DWORD required_time_stamp)
// path is in internal Windows format
// module name is for comparison and for log information
// if map file contains will not be in the order as MSVC 6.0 and 8.0 compiler makes, it will return "file broken"
bool CMapFile::LoadFile (DWORD required_time_stamp, bool* abort)
{
bool result;
//FILE* f;
// 256 is not enough :), biggest strings required little bit more
char buffer[GETS_BUFFER_SIZE];
//char buffer0[STRING_BUFFER_SIZE];
//char buffer1[STRING_BUFFER_SIZE];
char buffer2[STRING_BUFFER_SIZE];
char buffer3[STRING_BUFFER_SIZE];
char msg_box_text_sub[STRING_BUFFER_SIZE];
char msg_box_text[STRING_BUFFER_SIZE];
int i_result;
ulong dw_value;
CFileNT c_FileNT;
NTSTATUS status;
bool eof;
//ulong preferred_load_address;
bool map_file_loaded = 0;
wchar_t* wc_file_path = (wchar_t*)file_path;

	buffer[GETS_BUFFER_SIZE - 1] = 0;
	buffer2[STRING_BUFFER_SIZE - 1] = 0;
	buffer3[STRING_BUFFER_SIZE - 1] = 0;

	status = c_FileNT.Open (wc_file_path);
	if (status != STATUS_SUCCESS)
	{
		if (status == STATUS_OBJECT_NAME_NOT_FOUND || status == STATUS_NO_SUCH_FILE)
		{
			sprintf (msg_box_text_sub, "File not found.");
			goto not_found;
		}
		Error ("'CMapFile::LoadFile ()' :  Open () fail, status %08x", status);
		return 0;
	}

	eof = 0;

// -- module name --
	status = c_FileNT.GetS (buffer, GETS_BUFFER_SIZE, &eof);
	if (eof)
		goto file_broken;
	if (status)
	{
		Error ("'CMapFile::LoadFile ()' :  GetS () fail, status %08x", status);
		return 0;
	}

	sscanf (buffer, "%255s", buffer2);

	if (_strnicmp (buffer2, module_name, strlen (module_name)))
	{
		sprintf (msg_box_text_sub, "Module name isn't equal.\n(%s != %s)", buffer2, module_name);
		goto not_suitable;
	}

// -- timestamp --
	status = c_FileNT.GetS (buffer, GETS_BUFFER_SIZE, &eof);
	if (eof)
		goto file_broken;
	if (status)
	{
		Error ("'CMapFile::LoadFile ()' :  GetS () fail, status %08x", status);
		return 0;
	}
	status = c_FileNT.GetS (buffer, GETS_BUFFER_SIZE, &eof);
	if (eof)
		goto file_broken;
	if (status)
	{
		Error ("'CMapFile::LoadFile ()' :  GetS () fail, status %08x", status);
		return 0;
	}

	if (sscanf (buffer, " Timestamp is %255s", buffer2) != 1)
	{
		sprintf (msg_box_text_sub, "Timestamp string not read.");
		goto file_broken;
	}

	if (sscanf (buffer2, "%8x", &time_stamp) != 1)
	{
		sprintf (msg_box_text_sub, "Timestamp value (\"%s\") not readed.", buffer2);
		goto file_broken;
	}

	if (time_stamp != required_time_stamp)
	{
		LogFile_Printf ("----- Time stamp value not equal (%08x(.map) != %08x(image)) in map file \"%s\". -----\n", time_stamp, required_time_stamp, file_path);

#if 0
		int mb_result;
		char text[256];

		sprintf (text, "Time stamp value not equal (%08x(.map) != %08x(.exe)) in map file \"%s\".\nContinue anyway ?", time_stamp, required_time_stamp, file_path);

		mb_result = MessageBox (NULL,text,NULL,MB_YESNO);
//		mb_result = XMessageBox (NULL, text, NULL, MB_YESNO | MB_YESTOALL, NULL);

		if (mb_result == IDNO)
			return 0;
//		if (mb_result == IDYESTOALL)
//			skip_all_not_found = 1;
#endif

		sprintf (msg_box_text_sub, "Timestamp value is not equal (%08x(.map) != %08x(image)).", time_stamp, required_time_stamp);
		goto not_suitable;
	}

// info here is much detalized (containing information about subsections); such detalization will not be necessary for this project
#if 0
// -- module code main parameters --
// sections info must be read from exe, not from map
	while (! (status = c_FileNT.GetS (buffer, GETS_BUFFER_SIZE, &eof)))
	{
		int section_index;

		i_result = sscanf (buffer," %d:%255s %255s %255s %255s", &section_index, buffer0, buffer1, buffer2, buffer3);

		if (i_result > 0)
		{
			if (i_result != 5)
			{
				sprintf (msg_box_text_sub, "Module code subsection parameter (\"%s\") not read.", buffer);
				goto file_broken;
			}

			i_result = sscanf (buffer1, "%8xH", &dw_value);
			module_size = dw_value;

			goto main_param_ok;
		}
	}

//			sscanf (buffer0, "%8x", &dw_value);
//			module_code_beginning = dw_value;

	if (eof)
		goto file_broken;

	Error ("'CMapFile::LoadFile ()' :  GetS () fail, status %08x", status);
	return 0;

main_param_ok:
#endif

// -- skip, till  the functions' parameters --
	while (! (status = c_FileNT.GetS (buffer, GETS_BUFFER_SIZE, &eof)))
	{
		i_result = sscanf (buffer, "%255s", buffer2);

		if (i_result != 1)
			continue;

		if (! _stricmp (buffer2, "Address"))
			goto read_functions_parameters;
	}

	if (eof)
		goto file_broken;

	Error ("'CMapFile::LoadFile ()' :  GetS () fail, status %08x", status);
	return 0;

read_functions_parameters:

// -- read functions' parameters in array --
	while (! (status = c_FileNT.GetS (buffer, GETS_BUFFER_SIZE, &eof)))
	{
// perhaps is decimal, because begins from 1, while in debug info it is Sections[0]
		int section_index;
		char flags[5];

// "Address" (section index:offset) "Publics by Value" (symbols) "Rva+Base" (prefered address) [flags] "Lib:Object"
		i_result = sscanf (buffer, " %d:%8x %1023s %*8x%5c%255s", &section_index, &dw_value, buffer2, flags, buffer3);

		if (i_result >= 1)
// MSVC 8.0 map file have this mess
			if (section_index < 1)
				continue;

		if (i_result == 5)
		{
			int c_type;
			if (flags[0] != ' ' || flags[2] != ' ' || flags[4] != ' ')
				goto file_broken;
// letter "f" - function ? (I see only for functions)
			if (flags[1] != 'f')
				continue;
// letter "i" - '__inline' ?
			result = flags[3] == 'i';
			ConvertFunctionName (&c_type, buffer2);
			StoreFunction (section_index - 1, dw_value, c_type, buffer2, buffer3);
		}
		else if (! strncmp (buffer, " entry point at", 15))
			goto file_read_ok;
	}

	if (eof)
		goto file_broken;

	Error ("'CMapFile::LoadFile ()' :  GetS () fail, status %08x", status);
	return 0;

file_read_ok:
	map_file_loaded = 1;
	LogFile_Printf ("Map file read ok.\n");
	goto finish;

// todo :  add "retry"
not_found:
	if (! mapfile__skip_all__not_found)
	{
		sprintf (msg_box_text, "\"%S\"\n%s\nSkip not found .map file ?", file_path, msg_box_text_sub);
		PromptSkip (msg_box_text, &mapfile__skip_all__not_found, abort);
	}
	goto finish;

not_suitable:
	if (! mapfile__skip_all__not_suitable)
	{
		sprintf (msg_box_text, "\"%S\"\n%s\nSkip not suitable .map file ?", file_path, msg_box_text_sub);
		PromptSkip (msg_box_text, &mapfile__skip_all__not_suitable, abort);
	}
	goto finish;

file_broken:
	if (! mapfile__skip_all__broken)
	{
		sprintf (msg_box_text, "\"%S\"\n%s\nSkip broken .map file ?", file_path, msg_box_text_sub);
		PromptSkip (msg_box_text, &mapfile__skip_all__broken, abort);
	}
	goto finish;

finish:
	result = c_FileNT.Close ();
	if (! result)
	{
		Error ("'CMapFile::LoadFile ()' :  Close () fail");
	}

// lets stop care about it :)
//	if (number_of_functions <= 0)
//		LogFile_Printf ("----- Map file \"%s\" :  no functions were loaded. -----\n", file_path);

//	return number_of_functions > 0;
	return map_file_loaded;
}

// convert back to ordinary look
void CMapFile::ConvertFunctionName (int* c_type, char* func_name)
{
// 256 may be not enough
char temp[GETS_BUFFER_SIZE];
//char c_type[STRING_BUFFER_SIZE];
int known_type;

// find out type of C
	switch (func_name[0])
	{
	case '_':
//		strcpy (c_type, "(C)");
		*c_type = MAPFILE_CTYPE__C;
		known_type = 1;
		break;
	case '?':
//		strcpy (c_type, "(C++)");
		*c_type = MAPFILE_CTYPE__CPP;
		known_type = 1;
		break;
	default:
//		strcpy (c_type, "(?)");
		*c_type = MAPFILE_CTYPE__UNKNOWN;
		known_type = 0;
	}

	Strncpy (temp, &func_name[known_type], GETS_BUFFER_SIZE - 1);

	sprintf (func_name, "%s", temp);
}

//void CMapFile::GetFunctionTypeString (char* string_type, int c_type)
void MapFile_GetFunctionTypeString (char* string_type, int c_type)
{
	Assert(!! string_type);

	switch (c_type)
	{
	case MAPFILE_CTYPE__C:
		strcpy (string_type, "(C)");
		break;
	case MAPFILE_CTYPE__CPP:
		strcpy (string_type, "(C++)");
		break;
	case MAPFILE_CTYPE__UNKNOWN:
		strcpy (string_type, "(?)");
	default:
		strcpy (string_type, "(-error-)");
		Error ("CMapFile::GetFunctionTypeString () :  function C type is %d", c_type);
	}
}

// store function's information (in sorted by addresses array)
bool CMapFile::StoreFunction (int section_index, ulong offset, int c_type, char* func_name, char* obj_name)
{
map_file_section_info_t* section_info = &section_infos[section_index];
#define MAP_FIRST_ALLOC 16384
#define MAP_REALLOC_INCREASES 1024
int function_name_lenght;
int obj_name_lenght;
int increase_lenght;

	if (! function_names_buffer)
// first allocation
	{
		size_of_names_buffer = MAP_FIRST_ALLOC;
		function_names_buffer = (char*)malloc (size_of_names_buffer);
		if (! function_names_buffer)
			goto mem_alloc_error;
	}

// buffer usage lenght
	function_name_lenght = strlen (func_name) + 1;
	obj_name_lenght = strlen (obj_name) + 1;
	increase_lenght = function_name_lenght + obj_name_lenght;

	Assert(function_name_lenght < 1000);
	Assert(obj_name_lenght < 100);

	while (current_index_in_names_buffer + increase_lenght > size_of_names_buffer)
// increase buffer memory size
	{
	int i;
	int j;
	char* function_names_buffer_old = function_names_buffer;
	uint address_difference;

		size_of_names_buffer += MAP_REALLOC_INCREASES;
		function_names_buffer = (char*)realloc (function_names_buffer, size_of_names_buffer);
		if (! function_names_buffer)
			goto mem_alloc_error;
// correct pointers after reallocation
		address_difference = function_names_buffer - function_names_buffer_old;
		for (i = 0; i <= section_index; i++)
		{
			map_file_section_info_t* sect_info = &section_infos[i];

			for (j = 0; j < sect_info->number_of_functions; j++)
			{
				sect_info->map_file_function_infos[j].function_name += address_difference;
				sect_info->map_file_function_infos[j].obj_name += address_difference;
			}
		}
	}

map_file_function_info_t function_info;

	function_info.offset_begin = offset;
	function_info.c_type = c_type;
// put function name in buffer
	function_info.function_name = &function_names_buffer[current_index_in_names_buffer];
	strcpy (function_info.function_name, func_name);
	current_index_in_names_buffer += function_name_lenght;
// put .obj file name in buffer
	function_info.obj_name = &function_names_buffer[current_index_in_names_buffer];
	strcpy (function_info.obj_name, obj_name);
	current_index_in_names_buffer += obj_name_lenght;
	function_info.section_index = section_index;
	function_info.offset_in_image = image_sections[section_index].offset_begin + offset;

// store pointers and the value
	StoreFunctionParameters (section_index, &function_info);

	return 1;

mem_alloc_error:

	LogFile_Error ("***** Memory allocation error in 'CMapFile::StoreFunction () *****'\n");

	return 0;
}

// Store defined pointers and address (in sorted by addresses array of structures)
bool CMapFile::StoreFunctionParameters (int section_index, map_file_function_info_t* function_info)
{
map_file_section_info_t* section_info = &section_infos[section_index];
#define MAP_FUNC_FIRST_NUM 1024
#define MAP_FUNC_REALLOC_INCREASES 256
int i;
map_file_function_info_t val0,val1;
int move = 0;
int functions_info_buffer_size_old = section_info->functions_info_buffer_size;

	if (! section_info->map_file_function_infos)
// first allocation
	{
		section_info->functions_info_buffer_size = MAP_FUNC_FIRST_NUM;
		section_info->map_file_function_infos = (map_file_function_info_t*)malloc (section_info->functions_info_buffer_size * sizeof(map_file_function_info_t));
		if (! section_info->map_file_function_infos)
			goto mem_alloc_error;
	}

	section_info->number_of_functions++;

	if  (section_info->number_of_functions >= section_info->functions_info_buffer_size)
// increase buffer memory size
	{
		section_info->functions_info_buffer_size += MAP_REALLOC_INCREASES;
		section_info->map_file_function_infos = (map_file_function_info_t*)realloc (section_info->map_file_function_infos, section_info->functions_info_buffer_size * sizeof(map_file_function_info_t));
		if (! section_info->map_file_function_infos)
			goto mem_alloc_error;
	}

	if (functions_info_buffer_size_old != section_info->functions_info_buffer_size)
// size is changed
	{
// fill it with big values
		for (i = functions_info_buffer_size_old; i < section_info->functions_info_buffer_size; i++)
			section_info->map_file_function_infos[i].offset_begin = -1;
	}

// prepare
	val0 = *function_info;

// put info in buffer (in sorted by address order)
	for (i = 0; i < section_info->number_of_functions; i++)
	{
		if (! move)
		{
			if (val0.offset_begin < section_info->map_file_function_infos[i].offset_begin)
// activate move
				move = 1;
		}

// *note :  not "else"
		if (move)
		{
			val1 = section_info->map_file_function_infos[i];
			section_info->map_file_function_infos[i] = val0;
			val0 = val1;
		}
	}

	return 1;

mem_alloc_error:

	LogFile_Error ("***** Memory allocation error in 'CMapFile::StoreFunctionParameters () *****'\n");

	return 0;
}

// end offset (last) entry must be initialized also, cause it is not shown in map file
//bool CMapFile::Section_GetFunctionIndex (int* function_index, int section_index, ulong offset)
bool CMapFile::Section_GetFunctionInfo (map_file_function_info_t** map_file_function_info, int section_index, ulong offset)
{
map_file_section_info_t* section_info = &section_infos[section_index];
int i;

	for (i = 0; i < section_info->number_of_functions; i++)
	{
		if (offset < section_info->map_file_function_infos[i].offset_begin)
		{
			Assert(i > 0);
// *will be - previous function
			*map_file_function_info = &section_info->map_file_function_infos[i - 1];
			return 1;
		}
	}

	return 0;
}

#if 0
bool CMapFile::GetFunctionIndex (int* section_index, int* function_index, ulong offset)
{
int i;

//	for (i = 0; i < section_info->number_of_functions; i++)
	for (i = 0; i < SECTIONS_MAX; i++)
	{
		map_file_section_info_t* section_info = &section_infos[i];
		int index;

//		if (offset < section_info->begin)
//			continue;
//		if (offset >= section_info->begin + section_info->length)
//			continue;

		*section_index = i;
		index = Section_GetFunctionIndex (i, offset);
		*function_index = index;
		if (index >= 0)
			return 1;
		break;
	}

	return 0;
}
#endif

#if 0
bool CMapFile::GetFunctionIndex (int* function_index, int section_index, ulong offset)
{
	map_file_section_info_t* section_info = &section_infos[section_index];
	int index;
	index = Section_GetFunctionIndex (section_index, offset);
	*function_index = index;
	if (index >= 0)
		return 1;
	return 0;
}
#endif

CMapFile::~CMapFile ()
{
	int i;

//	if (map_file_function_infos)
//		free (map_file_function_infos);
	for (i = 0; i < SECTIONS_MAX; i++)
	{
		map_file_section_info_t* section_info = &section_infos[i];

		if (section_info->map_file_function_infos)
			free (section_info->map_file_function_infos);
	}
	if (function_names_buffer)
		free (function_names_buffer);
}
