// by Alexander Ilyin
// loading and getting of  module info from .map file
// *original belongs at the Drag Watcher project

#pragma once

#include <windows.h>

#include "types.h"
#include "settings.h"
#include "section.h"


#define FILE_NAME_MAX 256
//#define FUNCTION_NAME_MAX 256


enum
{
	MAPFILE_CTYPE__NONE,
	MAPFILE_CTYPE__UNKNOWN,
	MAPFILE_CTYPE__C,
	MAPFILE_CTYPE__CPP,
	MAPFILE_CTYPE_NUM
};

typedef struct
{
	uint offset_begin;
	int c_type;
	char* function_name; // pointer to names buffer
	char* obj_name; // pointer to names buffer
// + only for output +
	int section_index;
	uint offset_in_image;
// - only for output -
} map_file_function_info_t;

typedef struct
{
// all these info not necessary here
#if 0
	bool section_is_code;
	uint begin;
	uint length;
#endif
	map_file_function_info_t* map_file_function_infos;
	int functions_info_buffer_size; // allocated size (in 'map_file_function_info_t' units)
	int number_of_functions;
} map_file_section_info_t;


//#define MAPFILE_SECTIONS_MAX 256

// alignment inside a class is 2
class CMapFile
{
protected:
public:
	CMapFile ();

// *full path and with .map extention
// must be aligned by 4
	byte file_path[UPATH_MAX];
// *without extention
	char module_name[FILE_NAME_MAX];
// *with extention
//	char map_file_name[FILE_NAME_MAX];
	DWORD time_stamp;
// no such info in map file
//	ulong module_code_beginning;
	ulong module_size;
//	int not_decompiled_strings_num; // *for debug

// may be private, necessary only for Sorting_xxx ()
	map_file_section_info_t section_infos[SECTIONS_MAX];

private:
// + sections' data +
// pointer to image data
	section_t* image_sections;
	int image_sections_num;
// - sections' data -
// +++ functions' data +++
// names buffer
	char* function_names_buffer;
	int size_of_names_buffer; // allocated size
	int current_index_in_names_buffer; // names' finish point
// --- functions' data ---

public:
	bool Init (wchar_t* exe_file_path, char* module_file_name, section_t* sections, int sections_num);
	bool LoadFile (DWORD required_time_stamp, bool* abort);
//	bool GetFunctionIndex (int* section_index, int* function_index, ulong offset);
//	bool GetFunctionIndex (int* function_index, int section_index, ulong offset);
//	void GetFunctionTypeString (char* string_type, int c_type);
	bool StoreFunction (int section_index, ulong offset, int c_type, char* func_name, char* obj_name);
	bool Section_GetFunctionInfo (map_file_function_info_t** map_file_function_info, int section_index, ulong offset);

	~CMapFile ();

private:
	void PromptSkip (char* text, bool* flag__skip_all, bool* no);
	void ConvertFunctionName (int* c_type, char* func_name);
	bool StoreFunctionParameters (int section_index, map_file_function_info_t* function_info);
//	int Section_GetFunctionIndex (int section_index, ulong offset);

//	friend void Sorting_ByFunctions_Section (...);
};

void MapFile_GetFunctionTypeString (char* string_type, int c_type);

